<?php
/*
	class form
	// function elemInput($self) { self ???
*/

require_once ( $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate') . "plugins/function.formSafeValue.php" );
class phptemplate_plugin_class_form {
	protected $attrInTagArray = array();

	/*
		*** open ***
		@id
		// @name
		@action
		@method
		@attr (array)
	*/
	function open($id, /* $name, */ $action = "", $method = "post", $attr = array()) {
		$this->attrInTagArray = array();
		$this->_setAttr('id', $id);
		// $this->_setAttr('name', $name);
		if($action == ""){
			$action = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_URL');
		}
		$this->_setAttr('action', $action);
		$this->_setAttr('method', $method);
		$this->_setAttrArray($attr);
		return '<form'.implode("",$this->attrInTagArray).'>';
	}
	
	/*
		*** close ***
	*/
	function close() {
		return '</form>';
	}
	
	/*
		*** elemInput ***
		@id
		@name
		@value
		@attr (array)
	*/
	function elemInput($id, $name, $value, $attr = array()) {
		$this->attrInTagArray = array();
		$this->_setAttr('type', 'text');
		$this->_setAttr('id', $id);
		$this->_setAttr('name', $name);
		$this->_setAttr('value', $this->_elemValue($name,$value), 0);
		$this->_setAttrArray($attr);
		return '<input'.implode("",$this->attrInTagArray).'>';
	}
	
	/*
		*** elemHidden ***
		@id
		@name
		@value
		@attr (array)
	*/
	function elemHidden($id, $name, $value, $attr = array()) {
		$this->attrInTagArray = array();
		$this->_setAttr('type', 'hidden');
		$this->_setAttr('id', $id);
		$this->_setAttr('name', $name);
		$this->_setAttr('value', $this->_elemValue($name,$value), 0);
		$this->_setAttrArray($attr);
		return '<input'.implode("",$this->attrInTagArray).'>';
	}
	
	/*
		*** elemPassword ***
		@id
		@name
		@value
		@attr (array)
	*/
	function elemPassword($id, $name, $value, $attr = array()) {
		$this->attrInTagArray = array();
		$this->_setAttr('type', 'password');
		$this->_setAttr('id', $id);
		$this->_setAttr('name', $name);
		$this->_setAttr('value', $this->_elemValue($name,$value), 0);
		$this->_setAttrArray($attr);
		return '<input'.implode("",$this->attrInTagArray).'>';
	}
	
	/*
		*** elemCheckbox ***
		@id
		@name
		@value
		@indexChecked (array or string)
		@attr (array)
	*/
	function elemCheckbox($id, $name, $value, $indexChecked = FALSE, $attr = array()) {
		$this->attrInTagArray = array();
		$this->_setAttr('type', 'checkbox');
		$this->_setAttr('id', $id);
		$this->_setAttr('name', $name);
		$this->_setAttr('value', $value, 1);
		$this->_setAttr('checked', $this->_elemChecked($name,$value,$indexChecked));
		$this->_setAttrArray($attr);
		return '<input'.implode("",$this->attrInTagArray).'>';
	}
	
	/*
		*** elemRadio ***
		@id
		@name
		@value
		@indexChecked (array or string)
		@attr (array)
	*/
	function elemRadio($id, $name, $value, $indexChecked = FALSE, $attr = array()) {
		$this->attrInTagArray = array();
		$this->_setAttr('type', 'radio');
		$this->_setAttr('id', $id);
		$this->_setAttr('name', $name);
		$this->_setAttr('value', $value, 1);
		$this->_setAttr('checked', $this->_elemChecked($name,$value,$indexChecked));
		$this->_setAttrArray($attr);
		return '<input'.implode("",$this->attrInTagArray).'>';
	}
	
	/*
		*** elemSelect ***
		@id
		@name
		@items (array)
		@indexSelected (array or string)
		@attr_select (array)
		@attr_option (array)
	*/
	function elemSelect($id, $name, $items = array(), $indexSelected = FALSE, $attr_select = array(), $attr_option = array()) {
			
			// Attr select
		$this->attrInTagArray = array();
		$this->_setAttr('id', $id);
		$this->_setAttr('name', $name);
		$this->_setAttrArray($attr_select);
		$attrSelect = implode("",$this->attrInTagArray);		
			
			$out  = '';
			$out .= '<select'.$attrSelect.'>';
			foreach ($items as $k => $v){
				#$k = phptemplate_plugin_safeValue_array_varibles_stripslash($k);
				#$v = phptemplate_plugin_safeValue_array_varibles_stripslash($v);
				
					// Attr option
				$this->attrInTagArray = array();
				if(!empty($id)){
					$this->_setAttr('id', $id.'_option_'.$k);
				}
				$this->_setAttr('value', $k);
				$this->_setAttr('selected', $this->_elemSelected($name,$k,$indexSelected));
				//$this->_setAttrArray($attr_select);
				$attrOption = implode("",$this->attrInTagArray);
				$out .= '<option'.$attrOption.'>';
				$out .= $v;
				$out .= '</option>';
			}
			$out .= '</select>';
		
		return $out;
	}
	
		/*
			*** elemSelectMulti ***
			@id
			@name
			@items (array)
			@indexSelected (array or string)
			@attr_select (array)
			@attr_option (array)
		*/
		function elemSelectMulti($id, $name, $items = array(), $indexSelected = FALSE, $attr_select = array(), $attr_option = array()) {
			$attr_select['multiple'] = "multiple";
			return $this->elemSelect($id, $name, $items, $indexSelected, $attr_select, $attr_option);
		}
	
	/*
		*** elemTextarea ***
		@id
		@name
		@value
		@attr (array)
	*/
	function elemTextarea($id, $name, $value, $attr = array()) {
		$this->attrInTagArray = array();
		$this->_setAttr('type', 'text');
		$this->_setAttr('id', $id);
		$this->_setAttr('name', $name);
		$this->_setAttrArray($attr);
		return '<textarea'.implode("",$this->attrInTagArray).'>'.$this->_elemValue($name,$value).'</textarea>';
	}
	
	/*
		*** elemSubmit ***
		@id
		@name
		@value
		@attr (array)
	*/
	function elemSubmit($id, $name, $value, $attr = array()) {
		$this->attrInTagArray = array();
		$this->_setAttr('type', 'submit');
		$this->_setAttr('id', $id);
		$this->_setAttr('name', $name);
		$this->_setAttr('value', $this->_elemValue($name,$value), 0);
		$this->_setAttrArray($attr);
		return '<input'.implode("",$this->attrInTagArray).'>';
	}
	
	/*
		*** elemSubmitImage ***
		@id
		@name
		@value
		@src
		@attr (array)
	*/
	function elemSubmitImage($id, $name, $value, $src = "", $attr = array()) {
		$this->attrInTagArray = array();
		$this->_setAttr('type', 'image');
		$this->_setAttr('id', $id);
		$this->_setAttr('src', $src);
		$this->_setAttr('name', $name);
		$this->_setAttr('value', $this->_elemValue($name,$value), 0);
		$this->_setAttrArray($attr);
		return '<input'.implode("",$this->attrInTagArray).'>';
	}
	
	/*
		*** elemCaptchaInput ***
		@id
		@name
		@value
		@attr (array)
	*/
	function elemCaptchaInput($id, $name, $value, $attr = array()) {
		$this->attrInTagArray = array();
		$this->_setAttr('type', 'text');
		$this->_setAttr('id', $id);
		$this->_setAttr('name', $name);
		$this->_setAttr('value', $this->_elemValue($name,$value), 0);
		$this->_setAttr('onkeyup', "this.value = this.value.replace(/[^\d]+/g, '');");
		$this->_setAttr('maxlength', '5');
		$this->_setAttrArray($attr);
		return '<input'.implode("",$this->attrInTagArray).'>';
	}
	
		/*
			*** elemCaptchaImage ***
			@id_captcha_input_text
			@src
			@attr (array)
		*/
		function elemCaptchaImage($id_captcha_input_text, $src, $attr = array()) {
			$this->attrInTagArray = array();
				$id = $id_captcha_input_text.'_image';
				if(!empty($id_captcha_input_text)){
					$this->_setAttr('id', $id);
				}
			$this->_setAttr('src', PATH_captcha);
			$this->_setAttr('onclick', "reloadCaptcha_".md5($id)."(this); resetCaptchaInputText_".md5($id)."(this); return false;");
			$this->_setAttr('style', "border: none; cursor: pointer;");
			$this->_setAttrArray($attr);
			$out  = '';
			$out .= '<script> function reloadCaptcha_'.md5($id).'(obj) { var temp = obj.src; temp = temp.split("?"); obj.src = temp[0] + "?"+ Math.random() } </script>';
			$out .= '<script> function resetCaptchaInputText_'.md5($id).'(obj) { document.getElementById("'.$id_captcha_input_text.'").value=""; } </script>';
			$out .= '<img'.implode("",$this->attrInTagArray).'>';
			return $out;
		}	
	
	/*
		Вспомогательные функции
	*/
		// 1. Установка атрибута в тэге
	function _setAttr($name, $value, $htmlspecialchars = 1){
		if ($this->attrInTagArray[$name] == NULL && trim($value) != ""){ // && !empty($value)) {
			if ($htmlspecialchars == 0) {
				$this->attrInTagArray[$name] = ' '.$name.'="'.$value.'"';
			} else {
				$this->attrInTagArray[$name] = ' '.$name.'="'.htmlspecialchars($value).'"';
			}
		}
	}
		// 2. Установка атрибутов в тэге
	function _setAttrArray($attr_array){
		foreach ($attr_array as $name => $value){
			if ($name == "value"){
				// $this->_setAttr('value', $this->_elemValue($name,$value), 0);
			} else {
				$this->_setAttr($name, $value);
			}
		}	
	}
	
		// 3. Установка значения атрибута value="" 
	function _elemValue($name, $value){
		$name = $this->_getAttrName($name);
		if (isset($GLOBALS['_POST'][$name])){ // && empty($value)
			$str = $GLOBALS['_POST'][$name];
		} else {
			$str = $value;
		}
		#return phptemplate_plugin_safeValue_array_varibles_stripslash($str);
		return $str;
	}
	
		// 4. Установка значения атрибута checked="" 
	function _elemChecked($name, $value, $index = NULL){
		$name = $this->_getAttrName($name);
		if(!empty($GLOBALS['_POST'])){
			$index = $GLOBALS['_POST'][$name];
		}
			if (count($index) > 0 && in_array($value, $index)){
				$checked = 'checked';
			} elseif ($value == $index){
				$checked = 'checked';
			} else {
				$checked = '';
			}
		return $checked;
	}
	
		// 5. Установка значения атрибута selected="" 
	function _elemSelected($name, $value, $index = NULL){
		$name = $this->_getAttrName($name);
		if(!empty($GLOBALS['_POST'])){
			$index = $GLOBALS['_POST'][$name];
		}
			if (count($index) > 0 && in_array($value, $index)){
				$selected = 'selected';
			} elseif ($value == $index){
				$selected = 'selected';
			} else {
				$selected = '';
			}
		return $selected;
	}
	
		// 6. Получает имя элемента формы "name || name[0] || name[]"
	function _getAttrName($name){
		//$varible_from_post = eval("\$varible = \$GLOBALS['_POST']$name;");
		//print "\$varible = \$GLOBALS['_POST']$name;";
		if(strstr($name, '[')){
			$name = explode('[', $name);
			$name = $name[0];
		}
		return $name;
	}

}
?>