<?php
/*
	Todo:
		1. избавиться от тэгов <img, <br так, как во многих случаях они могут использоваться в js-скриптах
		2. isRecordLocked
		3. проверка прав на кнопку (искать в Total Commander по слову "editIcon"

	editIcon
	@table
	@recordId
	@title
	@otherArg
	@cssClassAbsolute
*/
function phptemplate_plugin_editIcon($self, $table = "tt_content", $recordId = 0, $title = "", $otherArg = array(), $cssClassAbsolute = 0) {
	return phptemplate_plugin_editIcon_marker($table, $recordId, $title, $otherArg, $cssClassAbsolute);
}

function phptemplate_plugin_editIcon_marker($table = "tt_content", $recordId = 0, $title = "", $otherArg = array(), $cssClassAbsolute = 0) {

		// При условии, что это режим редактирования
	if ($GLOBALS['BE_USER']->uc['phptemplate_mode_editing'] == 2) {
		if (is_array($otherArg)) {
			$otherArg = serialize($otherArg);
		}
		return "<!--@@@PHPTEMPLATE PANELEDITICON 
			tableName(".$table.")
			recordId(".$recordId.")
			title(".$title.")
			otherArg(".$otherArg.")
			cssClassAbsolute(".$cssClassAbsolute.")
		@@@-->";
	} else {
		return null;
	}
}

/*
function $val) {
	if (!empty($val)) {
		return $val;
	} else {
		return "-";
	}
}
*/

function phptemplate_plugin_editIcon_printOutput($arParams) {

	// $onclickConfirm = " onclick=' if (confirm(\"Выполнить действие?\")) { return true; } else { return false; } ' "; 
	$TYPO3_REQUEST_URL = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_URL');
	$TYPO3_REQUEST_URL_withOut_eIdAjax = phptemplate_plugin_editIcon_printOutput_clean_url_qs($TYPO3_REQUEST_URL, "eIdAjax");
	$TYPO3_REQUEST_URL_withOut_eIdAjax = phptemplate_plugin_editIcon_printOutput_addScrollLeftPositionParameter($TYPO3_REQUEST_URL_withOut_eIdAjax);

		// Unser otherArg
	$arParams['otherArg'] = unserialize($arParams['otherArg']);
	
		// Enable fields (hidden,deleted) for select query
	if (version_compare(TYPO3_branch, '6.2', '<')) {
		$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::loadTCA($arParams['tableName']);
	}
		$disableColumn 	= $GLOBALS['TCA'][$arParams['tableName']]['ctrl']['enablecolumns']['disabled'];
		$deletedColumn 	= $GLOBALS['TCA'][$arParams['tableName']]['ctrl']['delete'];
		$fieldSelectSpecial = array();
		
			if(!empty($disableColumn)){
				$fieldSelectSpecial[] = $disableColumn;
			}
	
			if(!empty($deletedColumn)){
				$fieldSelectSpecial[] = $deletedColumn;
			}
			
			if(count($fieldSelectSpecial)>0){
				$fieldSelectSpecial = "," . implode(",",$fieldSelectSpecial);
			}
	
	switch($arParams['tableName']) {
		case 'pages':
				$rowData = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getRecord($arParams['tableName'], $arParams['recordId'], "uid,pid,doktype".$fieldSelectSpecial);
				$colorBorder = "a2aab8";//DC143C
			break;
		case 'tt_content':
				if ($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::isLoaded('gridelements')) {
					// $rowData = DB::run()->table($arParams['tableName'])->select("uid,pid,colPos,CType,tx_gridelements_container,tx_gridelements_columns".$fieldSelectSpecial)->where('uid', '=', $arParams['recordId'])->disableEnableFieldsAll()->limit(1)->exec();
					$rowData = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getRecord($arParams['tableName'], $arParams['recordId'], "uid,pid,colPos,CType,list_type,tx_gridelements_container,tx_gridelements_columns".$fieldSelectSpecial);
					$rowData = $rowData; // [0]
					$colorBorder = "a2aab8";
				} else {
					// $rowData = DB::run()->table($arParams['tableName'])->select("uid,pid,colPos,CType".$fieldSelectSpecial)->where('uid', '=', $arParams['recordId'])->disableEnableFieldsAll()->limit(1)->exec();
					$rowData = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getRecord($arParams['tableName'], $arParams['recordId'], "uid,pid,colPos,CType,list_type".$fieldSelectSpecial);
					$rowData = $rowData; // [0]
					$colorBorder = "a2aab8";
				}
					// Если тип элемента контента - "Вставить записи (Insert Records)" или
					// "Вставить расширение (Insert Plugin)"- cssClassAbsolute выключаем
					// Т.к. иначе будет наложение кнопок редактирования друг на друга
				if ($rowData['CType'] == "shortcut" || $rowData['CType'] == "list" || $rowData['CType'] == "box" || $rowData['CType'] == "box_int") {
					$arParams['cssClassAbsolute'] = 0;
					$colorBorder = "a2aab8";//000000
				}
			break;
		case 'tx_air_table_marks':
				// $rowData = DB::run()->table($arParams['tableName'])->select("uid,pid,telem".$fieldSelectSpecial)->where('uid', '=', $arParams['recordId'])->disableEnableFieldsAll()->limit(1)->exec();
				$rowData = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getRecord($arParams['tableName'], $arParams['recordId'], "uid,pid,telem".$fieldSelectSpecial);
				$rowData = $rowData; // [0]
				$colorBorder = "a2aab8";//00BFFF
			break;
		default:
			
			// Если таблица является накопителем
			if(strstr($GLOBALS['TCA'][$arParams['tableName']]['ctrl']['title'], 'LLL:EXT:air_table')){
			
				// $rowData = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getRecord($arParams['tableName'], $arParams['recordId'], "uid,pid");
				// Добавляем копирование указанных колонок пользователем (для кнопки редактирования + новая запись на одной панельке)
				if(isset($arParams['otherArg']['copyFieldForNewIcon'])){
					$addField = explode(":" , $arParams['otherArg']['copyFieldForNewIcon']);
					$addField = $addField[0];
					# $rowData = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getRecord($arParams['tableName'], $arParams['recordId'], "uid,pid,telem,pelem,pelem_external,sorting,".$addField); // new
					$rowData = DB::run()->table($arParams['tableName'])->select("uid,pid,telem,pelem,pelem_external,sorting,".$addField.$fieldSelectSpecial)->where('uid', '=', $arParams['recordId'])->disableEnableFieldsAll()->limit(1)->exec();
					$rowData = $rowData[0];
				} else {
					# $rowData = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getRecord($arParams['tableName'], $arParams['recordId'], "uid,pid,telem,pelem,pelem_external,sorting"); // new
					$rowData = DB::run()->table($arParams['tableName'])->select("uid,pid,telem,pelem,pelem_external,sorting".$fieldSelectSpecial)->where('uid', '=', $arParams['recordId'])->disableEnableFieldsAll()->limit(1)->exec();
					$rowData = $rowData[0];
				}
				$colorBorder = "FFD700";//FFD700
				
			// Это все остальыне вроде tt_news...
			} else {

				// $rowData = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getRecord($arParams['tableName'], $arParams['recordId'], "uid,pid");
				// Добавляем копирование указанных колонок пользователем (для кнопки редактирования + новая запись на одной панельке)
				if(isset($arParams['otherArg']['copyFieldForNewIcon'])){
					$addField = explode(":" , $arParams['otherArg']['copyFieldForNewIcon']);
					$addField = $addField[0];
					$rowData = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getRecord($arParams['tableName'], $arParams['recordId'], "uid,pid,".$addField.$fieldSelectSpecial); // new
					$rowData = $rowData;
				} else {
					$rowData = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getRecord($arParams['tableName'], $arParams['recordId'], "uid,pid".$fieldSelectSpecial); // new
					$rowData = $rowData;
				}
				$colorBorder = "FFD700";//FFD700

			}
			
			break;
	}
	
	# $GLOBALS['count_tagEditIcon'] ++;
	$strEditIcon = "";
		
		/*
			// Если запись кем-то уже редактируется // Запрещяем редактирование // уничтожаем ссылку
		if ($lockInfo=$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::isRecordLocked($params['tableName'], $params['recordId'])){	
			$image = "
				<img src='/typo3conf/ext/phptemplate/res/icons/lock-warning.png' style='margin: 5px 0 0 7px;'
				title='Редактирует - " . $lockInfo['username'] . " - " . date("H:i:s" , $lockInfo['tstamp']) . "'>
			";				
		}
		*/
		
			// CSS class wrap 
		// if($arParams['otherArg']['center'] == 1){
			// $cssClassWrap = "phptemplate_tagEditIcon_wrap_center";
		// } else
		if($arParams['otherArg']['inlineBlock'] == 1){
			$cssClassWrap = "phptemplate_tagEditIcon_wrap_inline_block";
		} elseif ($arParams['cssClassAbsolute'] == 1) {
			$cssClassWrap = "phptemplate_tagEditIcon_wrap_absolute";
		} else {
			$cssClassWrap = "phptemplate_tagEditIcon_wrap_block";
		}
		
			// CSS - style top and left
		$styleTopAndLeft = '';
		if ($arParams['cssClassAbsolute'] == 1) {
			if(!empty($arParams['otherArg']['styleTop'])){ //  > 0
				$styleTopAndLeft .= ' top: '.$arParams['otherArg']['styleTop'].'px !important; ';
			}
			if(!empty($arParams['otherArg']['styleLeft'])){ //  > 0
				$styleTopAndLeft .= ' left: '.$arParams['otherArg']['styleLeft'].'px !important; ';
			}
		}
		
			// isPhpFilePath :: информация о пути к PHP-файлу
		if ($arParams['otherArg']['isPhpFilePath'] == 1) {
		/*
				// При условии, что включена шестеренка (настройки)
			if ($GLOBALS['BE_USER']->uc['phptemplate_checkOption'] == 1) { 
				
			}
		*/

			// goToModuleIcon :: пересылка к модулю в Backend
		} elseif ($arParams['otherArg']['isGoToModule']) {
			
			$colorBorder = "080808"; // black
			$strEditIcon .= "<!--TYPO3_NOT_SEARCH_begin-->";
			$strEditIcon .= "<tagEditIcon_wrap class='".$cssClassWrap."'>";
			$strEditIcon .= "<tagEditIcon class='phptemplate_tagEditIcon' style='border: #".$colorBorder." 2px solid; ".$styleTopAndLeft."'>";
			$strEditIcon .= "<nobr>";
			
					// goToModuleIcon Icon
				# $url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . "/typo3/alt_doc.php?&edit[".$arParams['tableName']."][". $arParams['recordId'] ."]=new&returnUrl=".$TYPO3_REQUEST_URL_withOut_eIdAjax.$defValsString;
				$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . "/typo3/mod.php?M=".$arParams['tableName']."&id=".$arParams['recordId']; // web_list
				$strEditIcon .= "<span class='tagEditIconA' onclick='".urlJsLocation($url)."' target='_blank'>";
				$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/goToModuleIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
				$strEditIcon .= ((trim($arParams['title']) != null) ? "&nbsp; " . $arParams['title'] : "");
				$strEditIcon .= "</span>";
			
			$strEditIcon .= "</nobr>";
			$strEditIcon .= "</tagEditIcon>";
			$strEditIcon .= "</tagEditIcon_wrap>";
			$strEditIcon .= "<tagEditIcon_br style='clear: left;'></tagEditIcon_br>";
			$strEditIcon .= "<!--TYPO3_NOT_SEARCH_end-->";
			
			// eventIcon :: кнопка редактирования с событием
		} elseif ($arParams['otherArg']['isEventIcon']) {
			
				// !!!Здесь замена параметрв!!!
			// $arParams['tableName']; // url
			// $arParams['recordId']; // icon
			// $arParams['title']; // title
			
			$colorBorder = "080808"; // black
			$strEditIcon .= "<!--TYPO3_NOT_SEARCH_begin-->";
			$strEditIcon .= "<tagEditIcon_wrap class='".$cssClassWrap."'>";
			$strEditIcon .= "<tagEditIcon class='phptemplate_tagEditIcon' style='border: #".$colorBorder." 2px solid; ".$styleTopAndLeft."'>";
			$strEditIcon .= "<nobr>";
			
					// eventIcon Icon
				# $url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . "/typo3/alt_doc.php?&edit[".$arParams['tableName']."][". $arParams['recordId'] ."]=new&returnUrl=".$TYPO3_REQUEST_URL_withOut_eIdAjax.$defValsString;
				# $url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . "/typo3/mod.php?M=".$arParams['tableName']."&id=".$arParams['recordId']; // web_list
				$url = $arParams['tableName'];
				$url = phptemplate_plugin_editIcon_printOutput_addScrollLeftPositionParameter($url);
				$strEditIcon .= "<span class='tagEditIconA' onclick='".urlJsLocation($url, 1)."'>";
				if(!empty($arParams['recordId'])){
					$icon = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . '/' . $arParams['recordId'];
					$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$icon.");'></tagEditIconImg class='tagEditIconImg'>";	
				}
				$strEditIcon .= ((trim($arParams['title']) != null) ? "&nbsp; " . $arParams['title'] : "");
				$strEditIcon .= "</span>";
			
			$strEditIcon .= "</nobr>";
			$strEditIcon .= "</tagEditIcon>";
			$strEditIcon .= "</tagEditIcon_wrap>";
			$strEditIcon .= "<tagEditIcon_br style='clear: left;'></tagEditIcon_br>";
			$strEditIcon .= "<!--TYPO3_NOT_SEARCH_end-->";
		
			// Edit New Icon :: for user table
		} elseif ($arParams['otherArg']['isNewRecord']) {
			
			$strEditIcon .= "<!--TYPO3_NOT_SEARCH_begin-->";
			$strEditIcon .= "<tagEditIcon_wrap class='".$cssClassWrap."'>";
			$strEditIcon .= "<tagEditIcon class='phptemplate_tagEditIcon' style='border: #".$colorBorder." 2px solid; ".$styleTopAndLeft."'>";
			$strEditIcon .= "<nobr>";
			
				// Если pid не определен (пробуем выбрать последний)
			$res = $GLOBALS['TYPO3_DB']->sql_query("
				SELECT pid FROM `".$arParams['tableName']."`
				GROUP BY pid
			");
			if ($GLOBALS['TYPO3_DB']->sql_num_rows ($res) > 0) {
				while ( ($ardamp = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) ) {
					$pidList[] = $ardamp['pid'];
				}
			}
				
				// Если не удалось установить хранилище (если pid много различных)
			if (count($pidList) > 1 && empty($arParams['recordId'])) {
			
					// New icon error
				$strEditIcon .= "<span class='tagEditIconA' >";
				$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/newIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
				$strEditIcon .= ((trim($arParams['title']) != null) ? "&nbsp; " . $arParams['title'] : "");
				$strEditIcon .= "</span>";
				
					// Hover wrap 
				$strEditIcon .= "<tagEditIconSpan class='phptemplate_tagEditIconSpan'>";
				$strEditIcon .= $GLOBALS['LANG']->sL('LLL:EXT:phptemplate/locallang.xml:plugins.editIcon.unableToEstablishTheRepository'); // $strEditIcon .= "- не удалось установить хранилище!"; // , создайте первую запись в ручную!
				$strEditIcon .= "</tagEditIconSpan>";
				
			} else {
					
					// Pid save (если не задан pid, берем из похоже записи
				if (empty($arParams['recordId'])) {
					$arParams['recordId'] = $pidList[0];
				}
			
					// Def Vals
				$defVals = $arParams['otherArg'];
				$defValsString = "";
				foreach ($defVals as $k_defVals => $v_defVals){
					if(trim($v_defVals) != NULL){
						$defValsString .= "&defVals[".$arParams['tableName']."][".$k_defVals."]=".urlencode($v_defVals);
					}
				}
			
					// New icon
				$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . "/typo3/alt_doc.php?&edit[".$arParams['tableName']."][". $arParams['recordId'] ."]=new&returnUrl=".$TYPO3_REQUEST_URL_withOut_eIdAjax.$defValsString;
				$strEditIcon .= "<span class='tagEditIconA' onclick='".urlJsLocation($url)."'>";
				$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/newIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
				$strEditIcon .= ((trim($arParams['title']) != null) ? "&nbsp; " . $arParams['title'] : "");
				$strEditIcon .= "</span>";
				
					// Hover wrap 
				$strEditIcon .= "<tagEditIconSpan class='phptemplate_tagEditIconSpan'>";
				$strEditIcon .= $arParams['tableName'].", save to pid: ". $arParams['recordId'];
				$strEditIcon .= "</tagEditIconSpan>";
			
			}
			
			$strEditIcon .= "</nobr>";
			$strEditIcon .= "</tagEditIcon>";
			$strEditIcon .= "</tagEditIcon_wrap>";
			$strEditIcon .= "<tagEditIcon_br style='clear: left;'></tagEditIcon_br>";
			$strEditIcon .= "<!--TYPO3_NOT_SEARCH_end-->";
		
			// Edit Icon - tt_content
		} elseif ($arParams['tableName'] == "tt_content") {
		
				// Убираем все другие кнопки, если идет перемещение
			if (isset($GLOBALS['_POST']['formSend_isMoveRecord_tt_content'])) {
				$arParams['otherArg']['isNewRecord_tt_content'] = FALSE;
				$arParams['otherArg']['isEditRecord_tt_content'] = FALSE;
			}
		
				// :: Move Icon
			if ($arParams['otherArg']['isMoveRecord_tt_content'] == 1) {
			
			/*
					// А) Перемещение производитм только в идентичные колонки, 
					// Б) Для перемещяемого элемента не выводим кнопку перемещения
					// В) При условии что pid-совпадает
				if ($GLOBALS['_POST']['colPos'] == $rowData['colPos'] && $GLOBALS['_POST']['uid'] != $rowData['uid'] && $GLOBALS['_POST']['pid'] == $rowData['pid']) {
			*/
			
					// А) Перемещение производитм только в идентичные колонки, 
					// Б) Для перемещяемого элемента не выводим кнопку перемещения
					// В) При условии что pid-совпадает
				if (
					// Для TYPO3 6.0+ (работает перемещение) - решил пока отказаться от этого
					# (version_compare(TYPO3_branch, '6.0', '>=') && $GLOBALS['_POST']['uid'] != $rowData['uid'] && $GLOBALS['_POST']['pid'] == $rowData['pid'])
					# ||
					// Для TYPO3 4.7.+ (перемещение между колонками не работает)
					# (/* version_compare(TYPO3_branch, '6.0', '<') && */

							// Пока решено оставить возможность перемещения только подобные элементы в плане колонок
						(
							$GLOBALS['_POST']['colPos'] == $rowData['colPos'] 
							&& 
							$GLOBALS['_POST']['gCon'] == $rowData['tx_gridelements_container'] 
							&&
							$GLOBALS['_POST']['gCol'] == $rowData['tx_gridelements_columns'] 
							&& 
							$GLOBALS['_POST']['pid'] == $rowData['pid']
							&&
							$GLOBALS['_POST']['uid'] != $rowData['uid'] 
						)
					)
				{
					$strEditIcon .= "<!--TYPO3_NOT_SEARCH_begin-->";
					$strEditIcon .= "<tagEditIcon_wrap class='".$cssClassWrap."'>";
					$strEditIcon .= "<tagEditIcon class='phptemplate_tagEditIcon' style='border: #".$colorBorder." 2px solid; ".$styleTopAndLeft."'>";
					$strEditIcon .= "<nobr>";
					
						// Move icon
					$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . phptemplate_plugin_editIcon_UrlTtContentMoveRecord('tt_content', $GLOBALS['_POST']['uid'], $rowData['uid'], $TYPO3_REQUEST_URL_withOut_eIdAjax);
					$strEditIcon .= "<span class='tagEditIconA' onclick='".urlJsLocation($url)."'>";
					$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/moveIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
					$strEditIcon .= ((trim($arParams['title']) != null) ? "&nbsp; " . $arParams['title'] : "");
					$strEditIcon .= "</span>";
					
						// Hover wrap 
					$strEditIcon .= "<tagEditIconSpan class='phptemplate_tagEditIconSpan'>";
					if ($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::isLoaded('gridelements')) {
						$strEditIcon .= " idContent=".$rowData['uid'].", pid=".$rowData['pid'].", colPos=".$rowData['colPos'].", gridContainer=".$rowData['tx_gridelements_container']." ";
					} else {
						$strEditIcon .= " idContent=".$rowData['uid'].", pid=".$rowData['pid'].", colPos=".$rowData['colPos']." ";
					}
					$strEditIcon .= "</tagEditIconSpan>";
					
					$strEditIcon .= "</nobr>";
					$strEditIcon .= "</tagEditIcon>";
					$strEditIcon .= "</tagEditIcon_wrap>";
					$strEditIcon .= "<tagEditIcon_br style='clear: left;'></tagEditIcon_br>";
					$strEditIcon .= "<!--TYPO3_NOT_SEARCH_end-->";

				} else {
					return NULL;
				}
		
				//  :: cWizard for tt_content
			} elseif ($arParams['otherArg']['isNewRecord_tt_content'] == 1) {

			/*
				# $arParams['otherArg']['isNewRecord_tt_content'];
				# $arParams['otherArg']['isNewRecord_tt_content_arValue'];
			*/
			
				$strEditIcon .= "<!--TYPO3_NOT_SEARCH_begin-->";
				$strEditIcon .= "<tagEditIcon_wrap class='".$cssClassWrap."'>";
				$strEditIcon .= "<tagEditIcon class='phptemplate_tagEditIcon' style='border: #".$colorBorder." 2px solid; ".$styleTopAndLeft."'>";
				$strEditIcon .= "<nobr>";
					
						// New icon
					/*
						Example link:
							&id=87
							&colPos=-1
							&tx_gridelements_container=564
							&tx_gridelements_columns=0
							&sys_language_uid=
							&uid_pid=87
					*/
					$getParams = array();
					$getParams['id'] 		= "&id=" . $arParams['otherArg']['isNewRecord_tt_content_arValue']['pid'];
					if ($arParams['otherArg']['isNewRecord_tt_content_arValue']['tx_gridelements_container'] > 0) {
						$getParams['colPos'] 	= "&colPos=-1";
						$getParams['gCon']		= "&tx_gridelements_container=" . $arParams['otherArg']['isNewRecord_tt_content_arValue']['tx_gridelements_container'];
						$getParams['gCol'] 		= "&tx_gridelements_columns=" . $arParams['otherArg']['isNewRecord_tt_content_arValue']['tx_gridelements_columns'];
					} else {
						$getParams['colPos'] 	= "&colPos=" . $arParams['otherArg']['isNewRecord_tt_content_arValue']['colPos'];
					}
					$getParams['sys_lang'] 	= "&sys_language_uid=0";
					$getParams['uid_pid']	= "&uid_pid=" . $arParams['otherArg']['isNewRecord_tt_content_arValue']['pid'];
					$getParams['returnUrl'] = "&returnUrl=".$TYPO3_REQUEST_URL_withOut_eIdAjax;
					
					$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . "/typo3/sysext/cms/layout/db_new_content_el.php?".implode("", $getParams);
					$strEditIcon .= "<span class='tagEditIconA' onclick='".urlJsLocation($url)."'>";
					$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/newIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
					$strEditIcon .= "&nbsp; " . $arParams['title'];
					$strEditIcon .= "</span>";
					
						// Hover wrap (more info record)
					$info = $getParams;
					$info['gCon'] = str_replace("tx_gridelements_container", "gridContainer", $info['gCon']);
					$info['gCol'] = str_replace("tx_gridelements_columns", "gridColumns", $info['gCol']);
					$info['sys_lang'] = null;
					$info['uid_pid'] = null;
					$info['returnUrl'] = null;
					$strEditIcon .= "<tagEditIconSpan class='phptemplate_tagEditIconSpan'>";
					$strEditIcon .= trim(str_replace("&", " ", implode("", $info)));
					$strEditIcon .= "</tagEditIconSpan>";
					
				$strEditIcon .= "</nobr>";
				$strEditIcon .= "</tagEditIcon>";
				$strEditIcon .= "</tagEditIcon_wrap>";
				$strEditIcon .= "<tagEditIcon_br style='clear: left;'></tagEditIcon_br>";
				$strEditIcon .= "<!--TYPO3_NOT_SEARCH_end-->";
			
				// :: Edit Icon
			} elseif ($arParams['otherArg']['isEditRecord_tt_content'] == 1) {
				
				$strEditIcon .= "<!--TYPO3_NOT_SEARCH_begin-->";
				$strEditIcon .= "<tagEditIcon_wrap class='".$cssClassWrap."'>";
				$strEditIcon .= "<tagEditIcon class='phptemplate_tagEditIcon' style='border: #".$colorBorder." 2px solid; ".$styleTopAndLeft."'>";
				$strEditIcon .= "<nobr>";

					// Edit icon
				$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . "/typo3/alt_doc.php?&edit[".$arParams['tableName']."][". $arParams['recordId'] ."]=edit&returnUrl=".$TYPO3_REQUEST_URL_withOut_eIdAjax;
				$strEditIcon .= "<span class='tagEditIconA' onclick='".urlJsLocation($url)."'>";
				$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/editIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
				$strEditIcon .= "</span>";
					
					// New icon 
				$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . "/typo3/sysext/cms/layout/db_new_content_el.php?id=".$GLOBALS['TSFE']->id."&colPos=".$rowData['colPos']."&sys_language_uid=0&uid_pid=-".$arParams['recordId']."&returnUrl=".$TYPO3_REQUEST_URL_withOut_eIdAjax;
				$strEditIcon .= "<span class='tagEditIconA' onclick='".urlJsLocation($url)."'>";
				$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/newIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
				$strEditIcon .= "</span>";
				
					// Hide icon
				if(isset($disableColumn)){ // && $arParams['otherArg']['hideDisableIcon'] == FALSE
					$typeIcon = $rowData[$disableColumn] == 1 ? 'undisableIcon' : 'disableIcon';
					$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . phptemplate_plugin_editIcon_UrlDisable($arParams['tableName'], $arParams['recordId'], $rowData[$disableColumn], $disableColumn, $TYPO3_REQUEST_URL_withOut_eIdAjax);
					$strEditIcon .= "<span class='tagEditIconA' onclick='".urlJsLocation($url,1)."'>";
					$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/".$typeIcon.".png);'></tagEditIconImg class='tagEditIconImg'>";
					$strEditIcon .= "</span>";
				}

					// Delete icon
				if(isset($deletedColumn)){ // && $arParams['otherArg']['hideDeletedIcon'] == FALSE
					$typeIcon = $rowData[$deletedColumn] == 1 ? 'undeletedIcon' : 'deletedIcon';
					$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . phptemplate_plugin_editIcon_UrlDeleted($arParams['tableName'], $arParams['recordId'], $rowData[$deletedColumn], $TYPO3_REQUEST_URL_withOut_eIdAjax);
					$strEditIcon .= "<span class='tagEditIconA' onclick='".urlJsLocation($url,1)."'>";
					$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/".$typeIcon.".png);'></tagEditIconImg class='tagEditIconImg'>";
					$strEditIcon .= "</span>";
				}
				
					// Hover wrap 
				$strEditIcon .= "<tagEditIconSpan class='phptemplate_tagEditIconSpan' style='padding-left: 10px !important;'>";
					
						// Move icon (for tt_content)
					$url = NULL;
					
						/*
							Bug c $I_FORM_MOVE (tt_content move)
							Здесь есть небольшой баг - если на сайте два раза и более выводится одна и таже кнопка редактирования
							, то кнопка перемещения не активируется, из-за того что на странице появляется
							несколько одинаковых <form id=...
						*/
						
					// $I_FORM_MOVE = $GLOBALS['phptemplate_plugin_moveRecordTtContent_COUNTER']++; // счетчик форм
					$I_FORM_MOVE = md5(serialize($rowData['uid']) . serialize($arParams)); 
					
					$strEditIcon .= "<form id=\"phptemplate_plugin_moveRecordTtContent_".$I_FORM_MOVE."\" method=\"post\">";
					$strEditIcon .= "	<input name=\"formSend_isMoveRecord_tt_content\" type=\"hidden\" value=\"1\">";
					$strEditIcon .= "	<input name=\"colPos\" type=\"hidden\" value=\"".$rowData['colPos']."\">";
					$strEditIcon .= "	<input name=\"gCon\" type=\"hidden\" value=\"".$rowData['tx_gridelements_container']."\">";
					$strEditIcon .= "	<input name=\"gCol\" type=\"hidden\" value=\"".$rowData['tx_gridelements_columns']."\">";
					$strEditIcon .= "	<input name=\"pid\" type=\"hidden\" value=\"".$rowData['pid']."\">";
					$strEditIcon .= "	<input name=\"uid\" type=\"hidden\" value=\"".$rowData['uid']."\">";
					$strEditIcon .= "</form>";
					$strEditIcon .= "<span class='tagEditIconA' 
						onclick=\"document.forms['phptemplate_plugin_moveRecordTtContent_".$I_FORM_MOVE."'].submit();\"
					>";
					/*
						var temp = prompt(\"Переместить запись (вверх +, вниз -)\", 100); 
						if (temp) {
							alert(temp);
						}
					*/
					$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/moveIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
					$strEditIcon .= "</span>";
					
						// Bufer icon (copy, cut)
					// copy - Beta
					$url = "";
					$strEditIcon .= "<span class='tagEditIconA' onclick='".urlJsLocation($url,2)."'>";
					$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/copyIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
					$strEditIcon .= "";
					$strEditIcon .= "</span>";
					//cut - Beta
					$url = "";
					$strEditIcon .= "<span class='tagEditIconA' onclick='".urlJsLocation($url,2)."' style='padding-right: 10px !important;'>";
					$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/cutIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
					$strEditIcon .= "";
					$strEditIcon .= "</span>";
			
				$strEditIcon .= $arParams['tableName'].": ".$rowData['uid'] . ", CType: " . $rowData['CType'];
					if($rowData['CType'] == "list"){
						$strEditIcon .= ", list_type: " . $rowData['list_type'];
					}
				$strEditIcon .= "</tagEditIconSpan>";
				
				$strEditIcon .= "</nobr>";
				$strEditIcon .= "</tagEditIcon>";
				$strEditIcon .= "</tagEditIcon_wrap>";
				$strEditIcon .= "<!--TYPO3_NOT_SEARCH_end-->";
			
			} else {
				return NULL;
			}

			// Edit Icon :: Other edit icon table
		} else {
		
			$strEditIcon .= "<!--TYPO3_NOT_SEARCH_begin-->";
			$strEditIcon .= "<tagEditIcon_wrap class='".$cssClassWrap."'>";
			$strEditIcon .= "<tagEditIcon class='phptemplate_tagEditIcon' style='border: #".$colorBorder." 2px solid; ".$styleTopAndLeft."'>";
			$strEditIcon .= "<nobr>";

				if (isset($arParams['otherArg']['columnsOnly'])){
						// Делаем columnsOnly_2 (в основном для EXT: xDbMySQL) - т.к. в нем исправлен баг, в "columnsOnly" не работает Hook -> getMainFields_preProcess()
						// "columnsOnly_2" - параметр определенный в "EXT: Boards"
						// в EXT: Boards сделано немного по другому... [username];[password]; "=edit&columnsOnly_2=[username];[password];"
					$arexTemp = explode(",",$arParams['otherArg']['columnsOnly']);
					$resTemp = array();
					foreach($arexTemp as $kCO2 => $vCO2){
						$resTemp[] = "[".$vCO2."];";
					}
					// $columnsOnly = '&columnsOnly='.$arParams['otherArg']['columnsOnly'];
					$columnsOnly = '&columnsOnly_2='.implode("",$resTemp);
				} else {
					$columnsOnly = '';
				}
			
				// Edit icon
			$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . "/typo3/alt_doc.php?&edit[".$arParams['tableName']."][". $arParams['recordId'] ."]=edit&returnUrl=".$TYPO3_REQUEST_URL_withOut_eIdAjax.$columnsOnly;
			$strEditIcon_1  = "<span class='tagEditIconA' onclick='".urlJsLocation($url)."'>";
			$strEditIcon_1 .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/editIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
			$strEditIcon_1 .= "</span>";
			
				// New icon (включено всегда)
			if($arParams['tableName'] != "tx_air_table_marks" && $arParams['otherArg']['hideNewIcon'] == FALSE){

						// Def Vals
					$defVals = array(
						'telem' 			=> urlencode($rowData['telem']),
						'pelem' 			=> urlencode($rowData['pelem']),
						'pelem_external' 	=> urlencode($rowData['pelem_external']),
						'sorting' 			=> urlencode($rowData['sorting']),
						//'bodytext' 		=> urlencode($rowData['bodytext']),
					);
						// Добавляем копирование указанных колонок пользователем
					if(isset($arParams['otherArg']['copyFieldForNewIcon'])){
						$addField = explode(":" , $arParams['otherArg']['copyFieldForNewIcon']);
						$addField = $addField[0];
						$addField = explode(",", $addField);
					}
					foreach ($addField as $kF => $vF){
						$defVals[$vF] = urlencode($rowData[$vF]);
					}
					
					$defValsString = "";
					foreach ($defVals as $k_defVals => $v_defVals){
						if(trim($v_defVals) != NULL){
							$defValsString .= "&defVals[".$arParams['tableName']."][".$k_defVals."]=".$v_defVals;
						}
					}
				
				$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . "/typo3/alt_doc.php?&edit[".$arParams['tableName']."][". $rowData['pid'] ."]=new&returnUrl=".$TYPO3_REQUEST_URL_withOut_eIdAjax.$defValsString;
				$strEditIcon_2  = "<span class='tagEditIconA' onclick='".urlJsLocation($url)."'>";
				$strEditIcon_2 .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/newIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
				$strEditIcon_2 .= "</span>";
			}
				
				// Hide icon
			if(isset($disableColumn) && $arParams['otherArg']['hideDisableIcon'] == FALSE){
				$typeIcon = $rowData[$disableColumn] == 1 ? 'undisableIcon' : 'disableIcon';
				$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . phptemplate_plugin_editIcon_UrlDisable($arParams['tableName'], $arParams['recordId'], $rowData[$disableColumn], $disableColumn, $TYPO3_REQUEST_URL_withOut_eIdAjax);
				$strEditIcon_3  = "<span class='tagEditIconA' onclick='".urlJsLocation($url,1)."'>";
				$strEditIcon_3 .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/".$typeIcon.".png);'></tagEditIconImg class='tagEditIconImg'>";
				$strEditIcon_3 .= "</span>";
			}

				// Delete icon
			if(isset($deletedColumn) && $arParams['otherArg']['hideDeletedIcon'] == FALSE){
				$typeIcon = $rowData[$deletedColumn] == 1 ? 'undeletedIcon' : 'deletedIcon';
				$url = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST') . phptemplate_plugin_editIcon_UrlDeleted($arParams['tableName'], $arParams['recordId'], $rowData[$deletedColumn], $TYPO3_REQUEST_URL_withOut_eIdAjax);
				$strEditIcon_4  = "<span class='tagEditIconA' onclick='".urlJsLocation($url,1)."'>";
				$strEditIcon_4 .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/".$typeIcon.".png);'></tagEditIconImg class='tagEditIconImg'>";
				$strEditIcon_4 .= "</span>";
			}

				// Если у нас запись удалена - все кнопки выключаем!
			if( $rowData[$deletedColumn] == 1 ) {
				$strEditIcon_1 = NULL;
				$strEditIcon_2 = NULL;
				$strEditIcon_3 = NULL;
			}
			
				// Собариаем кнопки
			$strEditIcon .= $strEditIcon_1; // edit
			$strEditIcon .= $strEditIcon_2; // new
			$strEditIcon .= $strEditIcon_3; // disable
			$strEditIcon .= $strEditIcon_4; // delete

				// Если все кнопки пусты - выводим вопросик...
			if($strEditIcon_1 == NULL AND $strEditIcon_2 == NULL AND $strEditIcon_3 == NULL AND $strEditIcon_4 == NULL ){
				$url = "#";
				$strEditIcon .= "<span class='tagEditIconA' >";
				$strEditIcon .= "<tagEditIconImg class='tagEditIconImg' style='background-image: url(".$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_REQUEST_HOST')."/typo3conf/ext/phptemplate/plugins/res/unknownIcon.png);'></tagEditIconImg class='tagEditIconImg'>";
				$strEditIcon .= "</span>";
			}
			
				// Title
			$strEditIcon .= ((trim($arParams['title']) != null) ? "" . $arParams['title'] . " &nbsp;" : "");
			
				// Hover wrap 
			$strEditIcon .= "<tagEditIconSpan class='phptemplate_tagEditIconSpan'>";
			$strEditIcon .= $arParams['tableName'].": ".$rowData['uid'];
			if ($arParams['tableName'] == "pages") {
				$strEditIcon .= ", doktype: " . $rowData['doktype'];
			} else {
				if (!empty($rowData['telem'])) {
					$strEditIcon .= ", telem: " . $rowData['telem'];
				}
			}
			$strEditIcon .= "</tagEditIconSpan>";
			
			$strEditIcon .= "</nobr>";
			$strEditIcon .= "</tagEditIcon>";
			$strEditIcon .= "</tagEditIcon_wrap>";
			// $strEditIcon .= "<tagEditIcon_br style='clear: left;'></tagEditIcon_br>";
			$strEditIcon .= "<!--TYPO3_NOT_SEARCH_end-->";

		}
		

			// Если необходимо скрыть всплывающую hover-подсказку
		if($arParams['otherArg']['hideHoverInfo'] == 1){
			$strEditIcon = preg_replace("#<tagEditIconSpan class='phptemplate_tagEditIconSpan'>.*?</tagEditIconSpan>#s", "", $strEditIcon); 
		}
		
		
			// При условии, что включена шестеренка (настройки)
			// Если она выключена, то редактирование маркеров не показываем!
		if ($GLOBALS['BE_USER']->uc['phptemplate_checkOption'] != 1 && $arParams['tableName'] == "tx_air_table_marks") { 
			// return NULL; // очищаем
		} elseif($GLOBALS['BE_USER']->uc['phptemplate_checkOption'] == 1 && $arParams['otherArg']['isPhpFilePath'] != 1) {
			// return NULL; // очищаем кнопки, кроме "isPhpFilePath"
		} else {
			
		}
	
	
		// В новых версиях тайпо поменялись ссылки на редактирование и формирование ключа token происходит по другому
	if (version_compare(TYPO3_branch, '7.0', '>=')) {
		
		$tokenEdit 					= \TYPO3\CMS\Backend\Utility\BackendUtility::getModuleUrl('record_edit');
		$tokenNewContentElement 	= \TYPO3\CMS\Backend\Utility\BackendUtility::getModuleUrl('new_content_element');
		$tokenTceDb 				= \TYPO3\CMS\Backend\Utility\BackendUtility::getModuleUrl('tce_db');
		$tokenModule 				= \TYPO3\CMS\Core\FormProtection\FormProtectionFactory::get('backend')->generateToken('moduleCall', $arParams['tableName']); // 2-ой параметр название модуля
			
		preg_match("/token\=(.*)/", $tokenEdit, $tokenEditMatch);
		preg_match("/token\=(.*)/", $tokenNewContentElement, $tokenNewContentElementMatch);
		preg_match("/token\=(.*)/", $tokenTceDb, $tokenTceDbMatch);
			
		$strEditIcon = str_replace("/typo3/alt_doc.php?", "/typo3/index.php?route=/record/edit&token=".$tokenEditMatch[1], $strEditIcon);
		$strEditIcon = str_replace("/typo3/sysext/cms/layout/db_new_content_el.php?", "/typo3/index.php?route=/record/content/new&token=".$tokenNewContentElementMatch[1]."&", $strEditIcon);
		$strEditIcon = str_replace("/typo3/tce_db.php?", "/typo3/index.php?route=/record/commit&token=".$tokenTceDbMatch[1]."&", $strEditIcon);
		$strEditIcon = str_replace("/typo3/mod.php?", "/typo3/index.php?moduleToken=".$tokenModule."&", $strEditIcon);
		
		return $strEditIcon;
	} else {		
		return $strEditIcon;
	}
	
}

	// remove $qs_key from query string of $url, return modified url value
function phptemplate_plugin_editIcon_printOutput_clean_url_qs($url, $qs_key) {

	// first split the url in two parts (at most)
	$parts = explode('?', $url, 2);

	// check whether query string is passed        
	if (isset($parts[1])) {
		// parse the query string into $params
		parse_str($parts[1], $params);

		// unset if $params contains $qs_key
		if (array_key_exists($qs_key, $params)) {
			// remove key
			unset($params[$qs_key]);
				// rebuild the url
				return $parts[0] . 
					(count($params) ? '?' . http_build_query($params) : '');
		}
		
	}
	
	// no change required
	return $url;

}

	// Добавляем параметр "ScrollLeftPosition" для сохранения позиции
function phptemplate_plugin_editIcon_printOutput_addScrollLeftPositionParameter($url){
	# print PHP_URL_QUERY;
	# $a = parse_url( $url );
	# print_r($a);
	# exit();
	$url = phptemplate_plugin_editIcon_printOutput_addScrollLeftPositionParameter_addGetParamToUrl($url, 'ScrollLeftPosition', 'XXX');
	return $url;
}

	function phptemplate_plugin_editIcon_printOutput_addScrollLeftPositionParameter_addGetParamToUrl($url, $varName, $value) {
			// Если не находит "ScrollLeftPosition" - добавляем
		if(!strstr($url, $varName)){
			$url .= (parse_url($url, PHP_URL_QUERY) ? '&' : '?') . $varName.'='.$value;
		
			// Если находит "ScrollLeftPosition" - меняем
		} elseif(strstr($url, $varName)){
			$url = preg_replace("/".$varName."=\d+/", $varName."=".$value, $url);

		} else {
			// 
		}
		
		return $url;
	}

/**
 * pasteUrl of the element (database and file)
 * For the meaning of $table and $uid, please read from ->makePasteCmdArray!!!
 * The URL will point to tce_file or tce_db depending in $table
 *
 * @param string Tablename (_FILE for files)
 * @param int $uidRecord
 * @param int $uidRecordAfter
 * @param int $setRedirect If set, then the redirect URL will point back to the current script, but with CB reset.
 * @return string
 */
function phptemplate_plugin_editIcon_UrlTtContentMoveRecord($table, $uid, $uidRecordAfter, $redirect) {

	# $formToken = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getUrlToken('tceAction');
	# $formprotection = \TYPO3\CMS\Core\FormProtection\FormProtectionFactory::get('TYPO3\\CMS\\Core\\FormProtection\\BackendFormProtection');
	# $formToken = $formprotection->generateToken('tceAction');
	# $moduleUrl = \TYPO3\CMS\Backend\Utility\BackendUtility::getModuleUrl('web_list');
	# <!--# location.href=\"/typo3/tce_db.php?&cmd[tt_content][".$params['recordId']."][move]=-\"+ temp +\"&redirect=" . $TYPO3_REQUEST_URL_withOut_eIdAjax . "\"-->
	# return '/typo3/tce_db.php?&cmd[tt_content][193][move]=251&redirect=' . $redirect;
	# $formProtection = bin2hex($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::generateRandomBytes(32));
 
	# print "<pre>";
	# print_r($formProtection);
	# exit();

	# $cmd['tt_content'][161]['undelete']=1;
	# $tce = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::makeInstance('t3lib_TCEmain');
	# $tce->start(array(),$cmd);
	# $tce->process_cmdmap();

		// TYPO3 7.0+
	if (version_compare(TYPO3_branch, '7.0', '>=')) {
		$formprotection = \TYPO3\CMS\Core\FormProtection\FormProtectionFactory::get();
		$formToken = $formprotection->generateToken('tceAction');
	
		// TYPO3 6.0
	} elseif (version_compare(TYPO3_branch, '6.0', '>=')) {
		$formprotection = \TYPO3\CMS\Core\FormProtection\FormProtectionFactory::get('TYPO3\\CMS\\Core\\FormProtection\\BackendFormProtection');
		$formToken = $formprotection->generateToken('tceAction');
	
		// TYPO3 4.5+
	} elseif (version_compare(TYPO3_branch, '4.5', '>=')) {
		$formprotection = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::makeInstance('t3lib_formprotection_BackendFormProtection');
		$formToken = $formprotection->generateToken('tceAction');
	} else {
	
	}
	
	$rU = '/typo3/tce_db.php?' .
		'&cmd[tt_content]['.$uid.'][move]=-'.$uidRecordAfter. // нужны только отрицательные числа... (но вот как добавить вверх)
		'&vC=' . $GLOBALS['BE_USER']->veriCode() .
		'&prErr=1' . 
		'&uPT=1' .
		'&formToken=' . $formToken . 
		'&redirect=' . rawurlencode($redirect);
		// '&CB[paste]=' . rawurlencode($table . '|' . $uid) .
		// '&CB[pad]=normal' .
	return $rU; 
}

/**
 * pasteUrl of the element (database and file)
 * For the meaning of $table and $uid, please read from ->makePasteCmdArray!!!
 * The URL will point to tce_file or tce_db depending in $table
 *
 * @param string Tablename (_FILE for files)
 * @param int $uidRecord
 * @param int $uidRecordAfter
 * @param int $setRedirect If set, then the redirect URL will point back to the current script, but with CB reset.
 * @return string
 */
function phptemplate_plugin_editIcon_UrlDeleted($table, $uid, $rowData_deletedColumn, $redirect){
	# $formToken = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getUrlToken('tceAction');
	# $formprotection = \TYPO3\CMS\Core\FormProtection\FormProtectionFactory::get('TYPO3\\CMS\\Core\\FormProtection\\BackendFormProtection');
	# $formToken = $formprotection->generateToken('tceAction');
	# $moduleUrl = \TYPO3\CMS\Backend\Utility\BackendUtility::getModuleUrl('web_list');
	# <!--# location.href=\"/typo3/tce_db.php?&cmd[tt_content][".$params['recordId']."][move]=-\"+ temp +\"&redirect=" . $TYPO3_REQUEST_URL_withOut_eIdAjax . "\"-->
	# return '/typo3/tce_db.php?&cmd[tt_content][193][move]=251&redirect=' . $redirect;
	# $formProtection = bin2hex($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::generateRandomBytes(32));
 
	# print "<pre>";
	# print_r($formProtection);
	# exit();

	# $cmd['tt_content'][161]['undelete']=1;
	# $tce = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::makeInstance('t3lib_TCEmain');
	# $tce->start(array(),$cmd);
	# $tce->process_cmdmap();
	
		// TYPO3 7.0+
	if (version_compare(TYPO3_branch, '7.0', '>=')) {
		$formprotection = \TYPO3\CMS\Core\FormProtection\FormProtectionFactory::get();
		$formToken = $formprotection->generateToken('tceAction');
	
		// TYPO3 6.0
	} elseif (version_compare(TYPO3_branch, '6.0', '>=')) {
		$formprotection = \TYPO3\CMS\Core\FormProtection\FormProtectionFactory::get('TYPO3\\CMS\\Core\\FormProtection\\BackendFormProtection');
		$formToken = $formprotection->generateToken('tceAction');
	
		// TYPO3 4.5+
	} elseif (version_compare(TYPO3_branch, '4.5', '>=')) {
		$formprotection = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::makeInstance('t3lib_formprotection_BackendFormProtection');
		$formToken = $formprotection->generateToken('tceAction');
	} else {
	
	}
	
	$type = $rowData_deletedColumn == 1 ? 'undelete' : 'delete';
	$rU = '/typo3/tce_db.php?' .
		'&cmd['.$table.']['.$uid.']['.$type.']=1'.
		'&vC=' . $GLOBALS['BE_USER']->veriCode() .
		'&prErr=1' . 
		'&uPT=1' .
		'&formToken=' . $formToken . 
		'&redirect=' . rawurlencode($redirect);
		// '&CB[paste]=' . rawurlencode($table . '|' . $uid) .
		// '&CB[pad]=normal' .
	return $rU;
}

/**
 * pasteUrl of the element (database and file)
 * For the meaning of $table and $uid, please read from ->makePasteCmdArray!!!
 * The URL will point to tce_file or tce_db depending in $table
 *
 * @param string Tablename (_FILE for files)
 * @param int $uidRecord
 * @param int $uidRecordAfter
 * @param int $setRedirect If set, then the redirect URL will point back to the current script, but with CB reset.
 * @return string
 */
function phptemplate_plugin_editIcon_UrlDisable($table, $uid, $rowData_disableColumn, $disableColumn, $redirect){
	# $formToken = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getUrlToken('tceAction');
	# $formprotection = \TYPO3\CMS\Core\FormProtection\FormProtectionFactory::get('TYPO3\\CMS\\Core\\FormProtection\\BackendFormProtection');
	# $formToken = $formprotection->generateToken('tceAction');
	# $moduleUrl = \TYPO3\CMS\Backend\Utility\BackendUtility::getModuleUrl('web_list');
	# <!--# location.href=\"/typo3/tce_db.php?&cmd[tt_content][".$params['recordId']."][move]=-\"+ temp +\"&redirect=" . $TYPO3_REQUEST_URL_withOut_eIdAjax . "\"-->
	# return '/typo3/tce_db.php?&cmd[tt_content][193][move]=251&redirect=' . $redirect;
	# $formProtection = bin2hex($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::generateRandomBytes(32));
 
	# print "<pre>";
	# print_r($formProtection);
	# exit();

	# $cmd['tt_content'][161]['undelete']=1;
	# $tce = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::makeInstance('t3lib_TCEmain');
	# $tce->start(array(),$cmd);
	# $tce->process_cmdmap();
	
		// TYPO3 7.0+
	if (version_compare(TYPO3_branch, '7.0', '>=')) {
		$formprotection = \TYPO3\CMS\Core\FormProtection\FormProtectionFactory::get();
		$formToken = $formprotection->generateToken('tceAction');
	
		// TYPO3 6.0
	} elseif (version_compare(TYPO3_branch, '6.0', '>=')) {
		$formprotection = \TYPO3\CMS\Core\FormProtection\FormProtectionFactory::get('TYPO3\\CMS\\Core\\FormProtection\\BackendFormProtection');
		$formToken = $formprotection->generateToken('tceAction');
	
		// TYPO3 4.5+
	} elseif (version_compare(TYPO3_branch, '4.5', '>=')) {
		$formprotection = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::makeInstance('t3lib_formprotection_BackendFormProtection');
		$formToken = $formprotection->generateToken('tceAction');
	} else {
	
	}
	
	$num = $rowData_disableColumn == 1 ? 0 : 1;
	$rU = '/typo3/tce_db.php?' .
		'&data['.$table.']['.$uid.']['.$disableColumn.']='.$num.
		'&vC=' . $GLOBALS['BE_USER']->veriCode() .
		'&prErr=1' . 
		'&uPT=1' .
		'&formToken=' . $formToken . 
		'&redirect=' . rawurlencode($redirect);
		// '&CB[paste]=' . rawurlencode($table . '|' . $uid) .
		// '&CB[pad]=normal' .
	return $rU; 
	
}

	function urlJsLocation($url, $mode = 0){
		switch($mode){
			case 0: // default
				$js = ' window.location.href="'.$url.'"; return false; ';
			break;
			case 1: // with confirm
				$js = ' if (confirm("Выполнить действие?")) { window.location.href="'.$url.'"; return false; } else { return false; }  ';
			break; 
			case 2: // beta
				$js = ' alert("Beta!"); return false; ';
			break;
		}
		return $js;
	}
?>