<?php
/*
	recordStatus
	@table
	@recordId
*/
function phptemplate_plugin_recordStatus($self, $table = "tt_content", $recordId = 0) {
	if(isset($table) && isset($GLOBALS['TCA'][$table])){
		if (version_compare(TYPO3_branch, '6.2', '<')) {
			$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::loadTCA($table);
		}
		$disableColumn 	= $GLOBALS['TCA'][$table]['ctrl']['enablecolumns']['disabled'];
		$deletedColumn 	= $GLOBALS['TCA'][$table]['ctrl']['delete'];
		$fieldSelect = array();
		$fieldSelect[] = 'uid';
		
			if(!empty($disableColumn)){
				$fieldSelect[] = $disableColumn;
			}
	
			if(!empty($deletedColumn)){
				$fieldSelect[] = $deletedColumn;
			}
		
		if(class_exists("DB")){
			$row = DB::run()->table($table)->select(implode(",", $fieldSelect))->where('uid', '=', $recordId)->disableEnableFieldsAll()->limit(1)->exec();
		} else {
			$row = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_BEfunc']::getRecord($table, $recordId, implode(",", $fieldSelect));
			$row[0] = $row;
		}
		
		if((!empty($deletedColumn) && $row[0][$deletedColumn] == 1) || $row[0]['uid'] <= 0){
			return '<span style="color: gray;">(Удален)</span>';
		} elseif (!empty($disableColumn) && $row[0][$disableColumn] == 1) {
			return '<span style="color: red;">(Выключен)</span>';	
		} else {
			return '<span style="color: green;">(Активен)</span>';
		}
	}
	return '???';
}

?>