<?php
/*
	tpl_render_JS
	@addJsToFooter = 1
*/
function phptemplate_plugin_tpl_render_JS($self, $addJsToFooter = FALSE) {

	$jsFilesArray = array();
	$jsFooterFilesArray = array();
	$jsInlineArray = array();
	$jsFooterInlineArray = array();
		
		/**********************************************************************/
		/* includeCSS
		/* config.includeJS {,
		/* config.includeJSFooter {,
		/* config.jsInline {,
		/* config.jsFooterInline {,
		/*
		/* }
		/**********************************************************************/

			// JavaScript files
		if (is_array($GLOBALS['TSFE']->pSetup['includeJS.'])) {
			foreach ($GLOBALS['TSFE']->pSetup['includeJS.'] as $key => $JSfile) {
				if (!is_array($JSfile)) {
					if (isset($GLOBALS['TSFE']->pSetup['includeJS.'][$key . '.']['if.'])
						&& !$GLOBALS['TSFE']->cObj->checkIf($GLOBALS['TSFE']->pSetup['includeJS.'][$key . '.']['if.'])) {
						continue;
					}
					$ss = $GLOBALS['TSFE']->pSetup['includeJS.'][$key . '.']['external'] ? $JSfile : $GLOBALS['TSFE']->tmpl->getFileName($JSfile);
					if ($ss) {
						$type = $GLOBALS['TSFE']->pSetup['includeJS.'][$key . '.']['type'];
						if (! $type) {
							$type = 'text/javascript';
						}
						$jsFilesArray = phptemplate_plugin_tpl_render_JS_addJsFile(
							$jsFilesArray,
							$ss,
							$type,
							empty($GLOBALS['TSFE']->pSetup['includeJS.'][$key . '.']['disableCompression']),
							$GLOBALS['TSFE']->pSetup['includeJS.'][$key . '.']['forceOnTop'] ? TRUE : FALSE,
							$GLOBALS['TSFE']->pSetup['includeJS.'][$key . '.']['allWrap'],
							$GLOBALS['TSFE']->pSetup['includeJS.'][$key . '.']['excludeFromConcatenation'] ? TRUE : FALSE
						);
					}
				}
			}
		}

		if (is_array($GLOBALS['TSFE']->pSetup['includeJSFooter.'])) {
			foreach ($GLOBALS['TSFE']->pSetup['includeJSFooter.'] as $key => $JSfile) {
				if (!is_array($JSfile)) {
					if (isset($GLOBALS['TSFE']->pSetup['includeJSFooter.'][$key . '.']['if.'])
						&& !$GLOBALS['TSFE']->cObj->checkIf($GLOBALS['TSFE']->pSetup['includeJSFooter.'][$key . '.']['if.'])) {
						continue;
					}
					$ss = $GLOBALS['TSFE']->pSetup['includeJSFooter.'][$key . '.']['external'] ? $JSfile : $GLOBALS['TSFE']->tmpl->getFileName($JSfile);
					if ($ss) {
						$type = $GLOBALS['TSFE']->pSetup['includeJSFooter.'][$key . '.']['type'];
						if (! $type) {
							$type = 'text/javascript';
						}
						$jsFooterFilesArray = phptemplate_plugin_tpl_render_JS_addJsFooterFile(
							$jsFooterFilesArray,
							$ss,
							$type,
							empty($GLOBALS['TSFE']->pSetup['includeJSFooter.'][$key . '.']['disableCompression']),
							$GLOBALS['TSFE']->pSetup['includeJSFooter.'][$key . '.']['forceOnTop'] ? TRUE : FALSE,
							$GLOBALS['TSFE']->pSetup['includeJSFooter.'][$key . '.']['allWrap'],
							$GLOBALS['TSFE']->pSetup['includeJSFooter.'][$key . '.']['excludeFromConcatenation'] ? TRUE : FALSE
						);
					}
				}
			}
		}
		
			//add inline JS
		$inlineJS = '';

			// defined in php
		if (is_array($GLOBALS['TSFE']->inlineJS)) {
			foreach ($GLOBALS['TSFE']->inlineJS as $key => $val) {
				if (! is_array($val)) {
					$inlineJS .= LF . $val . LF;
				}
			}
		}

			// defined in TS with page.inlineJS
			// Javascript inline code
		$inline = $GLOBALS['TSFE']->cObj->cObjGet($GLOBALS['TSFE']->pSetup['jsInline.'], 'jsInline.');
		if ($inline) {
			$inlineJS .= LF . $inline . LF;
		}

			// Javascript inline code for Footer
		$inlineFooterJs = $GLOBALS['TSFE']->cObj->cObjGet($GLOBALS['TSFE']->pSetup['jsFooterInline.'], 'jsFooterInline.');


		if (! $GLOBALS['TSFE']->config['config']['removeDefaultJS']) {
				// inlude default and inlineJS
			$scriptJsCode = "var abc = 1";
			if ($scriptJsCode) {
				$jsInlineArray = phptemplate_plugin_tpl_render_JS_addJsInlineCode($jsInlineArray, '_scriptCode', $scriptJsCode, $GLOBALS['TSFE']->config['config']['compressJs']);
			}
			if ($inlineJS) {
				$jsInlineArray = phptemplate_plugin_tpl_render_JS_addJsInlineCode($jsInlineArray, 'TS_inlineJS', $inlineJS, $GLOBALS['TSFE']->config['config']['compressJs']);
			}
			if ($inlineFooterJs) {
				$jsFooterInlineArray = phptemplate_plugin_tpl_render_JS_addJsFooterInlineCode($jsFooterInlineArray, 'TS_inlineFooter', $inlineFooterJs, $GLOBALS['TSFE']->config['config']['compressJs']);
			}
		
		#######################################################################################
		# Так и не прояснилось, для чего нужно...
		#######################################################################################
		#} elseif ($GLOBALS['TSFE']->config['config']['removeDefaultJS'] === 'external') {
		#	/*
		#	 This keeps inlineJS from *_INT Objects from being moved to external files.
		#	 At this point in frontend rendering *_INT Objects only have placeholders instead
		#	 of actual content so moving these placeholders to external files would
		#	 	a) break the JS file (syntax errors due to the placeholders)
		#	 	b) the needed JS would never get included to the page
		#	 Therefore inlineJS from *_INT Objects must not be moved to external files but
		#	 kept internal.
		#	*/
		#	$inlineJSint = '';
		#	self::stripIntObjectPlaceholder($inlineJS, $inlineJSint);
		#	if ($inlineJSint) {
		#		$jsInlineArray = phptemplate_plugin_tpl_render_JS_addJsInlineCode($jsInlineArray, 'TS_inlineJSint', $inlineJSint, $GLOBALS['TSFE']->config['config']['compressJs']);
		#	}
		#	$jsFilesArray = phptemplate_plugin_tpl_render_JS_addJsFile($jsFilesArray, TSpagegen::inline2TempFile($scriptJsCode . $inlineJS, 'js'), 'text/javascript', $GLOBALS['TSFE']->config['config']['compressJs']);
		#
		#	if ($inlineFooterJs) {
		#		$inlineFooterJSint = '';
		#		self::stripIntObjectPlaceholder($inlineFooterJs, $inlineFooterJSint);
		#		if ($inlineFooterJSint) {
		#			$jsFooterInlineArray = phptemplate_plugin_tpl_render_JS_addJsFooterInlineCode($jsFooterInlineArray, 'TS_inlineFooterJSint', $inlineFooterJSint, $GLOBALS['TSFE']->config['config']['compressJs']);
		#		}
		#		$jsFooterFilesArray = phptemplate_plugin_tpl_render_JS_addJsFooterFile($jsFooterFilesArray, TSpagegen::inline2TempFile($inlineFooterJs, 'js'), 'text/javascript', $GLOBALS['TSFE']->config['config']['compressJs']);
		#	}
		} else {
				// include only inlineJS
			if ($inlineJS) {
				$jsInlineArray = phptemplate_plugin_tpl_render_JS_addJsInlineCode($jsInlineArray, 'TS_inlineJS', $inlineJS, $GLOBALS['TSFE']->config['config']['compressJs']);
			}
			if ($inlineFooterJs) {
				$jsFooterInlineArray = phptemplate_plugin_tpl_render_JS_addJsFooterInlineCode($jsFooterInlineArray, 'TS_inlineFooter', $inlineFooterJs, $GLOBALS['TSFE']->config['config']['compressJs']);
			}
		}
		
	
		/**********************************************************************/
		/* Вывод
		/*
		/*
		/**********************************************************************/
		#print_r ($jsFilesArray);
		#print_r ($jsFooterFilesArray);
		#print_r ($jsInlineArray);
		#print_r ($jsFooterInlineArray);
		
		if ($addJsToFooter == TRUE) {
			$jsFilesArray = $jsFooterFilesArray;
			$jsInlineArray = $jsFooterInlineArray;
		}
		
		if (count($jsFilesArray)) {
			foreach ($jsFilesArray as $name => $properties) {
				$properties['file'] = t3lib_div::resolveBackPath($properties['file']);
				$properties['file'] = t3lib_div::createVersionNumberedFilename($properties['file']);
				$tag = '<script src="' . htmlspecialchars($properties['file']) . '" type="' . htmlspecialchars($properties['type']) . '"></script>';
				if ($properties['allWrap'] && strpos($properties['allWrap'], '|') !== FALSE) {
					$tag = str_replace('|', $tag, $properties['allWrap']);
				}
				if ($properties['forceOnTop']) {
					if ($properties['section'] == 'PART_HEADER') {
						$jsFiles = TAB . $tag . LF . $jsFiles;
					} else {
						$jsFooterFiles = TAB . $tag . LF . $jsFooterFiles;
					}
				} else {
					if ($properties['section'] == 'PART_HEADER') {
						$jsFiles .= LF . TAB . $tag;
					} else {
						$jsFooterFiles .= LF . TAB . $tag;
					}
				}
			}
		}

		if (count($jsInlineArray)) {
			foreach ($jsInlineArray as $name => $properties) {
				if ($properties['forceOnTop']) {
					if ($properties['section'] == 'PART_HEADER') {
						$jsInline = '/*' . htmlspecialchars($name) . '*/' . LF . $properties['code'] . LF . $jsInline;
					} else {
						$jsFooterInline = '/*' . htmlspecialchars($name) . '*/' . LF . $properties['code'] . LF . $jsFooterInline;
					}
				} else {
					if ($properties['section'] == 'PART_HEADER') {
						$jsInline .= '/*' . htmlspecialchars($name) . '*/' . LF . $properties['code'] . LF;
					} else {
						$jsFooterInline .= '/*' . htmlspecialchars($name) . '*/' . LF . $properties['code'] . LF;
					}
				}
			}
		}

		$inlineJavascriptWrap = array(
			'<script type="text/javascript">' . LF . '/*<![CDATA[*/' . LF . '<!-- ' . LF,
			'// -->' . LF . '/*]]>*/' . LF . '</script>' . LF
		);
		
		if ($jsInline) {
			$jsInline = LF.LF.$inlineJavascriptWrap[0] . LF . $jsInline . LF . $inlineJavascriptWrap[1];
		}

		if ($jsFooterInline) {
			$jsFooterInline = LF.LF.$inlineJavascriptWrap[0] . LF . $jsFooterInline . LF . $inlineJavascriptWrap[1];
		}

	if ($addJsToFooter == TRUE) {
		$JsTags = LF.TAB."<!--JS (section for footer 1)-->";
	} else {
		$JsTags = LF.TAB."<!--JS (section for head 4)-->";
	}
	
	$JsTags .= $jsFiles;
	$JsTags .= $jsFooterFiles;
	$JsTags .= $jsInline;
	$JsTags .= $jsFooterInline;
	$JsTags .= LF;
	return $JsTags;

}

	/**
	 * Adds JS file
	 *
	 * @param string $file File name
	 * @param string $type Content Type
	 * @param boolean $compress
	 * @param boolean $forceOnTop
	 * @param string $allWrap
	 * @param boolean $excludeFromConcatenation
	 * @return void
	 */
	function phptemplate_plugin_tpl_render_JS_addJsFile($jsFilesArray, $file, $type = 'text/javascript', $compress = TRUE, $forceOnTop = FALSE, $allWrap = '', $excludeFromConcatenation = FALSE) {
		if (!$type) {
			$type = 'text/javascript';
		}
		if (!isset($jsFilesArray[$file])) {
			if (strpos($file, 'ajax.php?') !== FALSE) {
				$compress = FALSE;
			}
			$jsFilesArray[$file] = array(
				'file' => $file,
				'type' => $type,
				'section' => 'PART_HEADER', //self::PART_HEADER,
				'compress' => $compress,
				'forceOnTop' => $forceOnTop,
				'allWrap' => $allWrap,
				'excludeFromConcatenation' => $excludeFromConcatenation,
			);
		}
		return $jsFilesArray;
	}

	/**
	 * Adds JS file to footer
	 *
	 * @param string $file File name
	 * @param string $type Content Type
	 * @param boolean $compress
	 * @param boolean $forceOnTop
	 * @param string $allWrap
	 * @param boolean $excludeFromConcatenation
	 * @return void
	 */
	function phptemplate_plugin_tpl_render_JS_addJsFooterFile($jsFooterFilesArray, $file, $type = 'text/javascript', $compress = TRUE, $forceOnTop = FALSE, $allWrap = '', $excludeFromConcatenation = FALSE) {
		if (!$type) {
			$type = 'text/javascript';
		}
		if (!isset($jsFooterFilesArray[$file])) {
			if (strpos($file, 'ajax.php?') !== FALSE) {
				$compress = FALSE;
			}
			$jsFooterFilesArray[$file] = array(
				'file' => $file,
				'type' => $type,
				'section' => 'PART_FOOTER', //self::PART_FOOTER,
				'compress' => $compress,
				'forceOnTop' => $forceOnTop,
				'allWrap' => $allWrap,
				'excludeFromConcatenation' => $excludeFromConcatenation,
			);
		}
		return $jsFooterFilesArray;
	}

	/*Javascript Inline Blocks */

	/**
	 * Adds JS inline code
	 *
	 * @param string $name
	 * @param string $block
	 * @param boolean $compress
	 * @param boolean $forceOnTop
	 * @return void
	 */
	function phptemplate_plugin_tpl_render_JS_addJsInlineCode($jsInlineArray, $name, $block, $compress = TRUE, $forceOnTop = FALSE) {
		if (!isset($jsInlineArray[$name]) && !empty($block)) {
			$jsInlineArray[$name] = array(
				'code' => $block . LF,
				'section' => 'PART_HEADER', //self::PART_HEADER,
				'compress' => $compress,
				'forceOnTop' => $forceOnTop
			);
		}
		return $jsInlineArray;
	}

	/**
	 * Adds JS inline code to footer
	 *
	 * @param string $name
	 * @param string $block
	 * @param boolean $compress
	 * @param boolean $forceOnTop
	 * @return void
	 */
	function phptemplate_plugin_tpl_render_JS_addJsFooterInlineCode($jsFooterInlineArray, $name, $block, $compress = TRUE, $forceOnTop = FALSE) {
		if (!isset($jsFooterInlineArray[$name]) && !empty($block)) {
			$jsFooterInlineArray[$name] = array(
				'code' => $block . LF,
				'section' => 'PART_FOOTER', //self::PART_FOOTER,
				'compress' => $compress,
				'forceOnTop' => $forceOnTop
			);
		}
		return $jsFooterInlineArray;
	}