<?php
# require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'pi1/tsCondition-2-ConvertToUser_INT.php');
require_once ($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'pi1/pageTypeColor.php');

class tx_phptemplate_configArrayPostProc {

	protected $eIdAjaxTsParams = '';
	protected $eIdAjaxSerched = 0;

	public function configArrayPostProc($conf, &$object) {
			
			// toplevel - objArrayName
		# $object->sPre = $this->tmpl->setup['types.'][$this->type];
		# $object->pSetup = $this->tmpl->setup[$this->sPre . '.'];

		$this->cObjPhpTemplate_convert2Int($object); // convert2IntIfSendPost,convert2IntIfWhitePage,convert2IntIfFeUserAuthorization - конвертация объекта в "_INT"
		$this->eIdAjaxWillRun($object); // проверка - нужно ли запускать страницу "http://site-name.ru/index.php?id=1&eIdAjax=1"
		$this->setTitleTagValueAlternative($object); // альтернативный title
		$this->setBaseUrlIfEmpty($object); // если пустой BaseURL - устанавливаем его
		$this->setAbsRefPrefixIfEmpty($object); // если пустой AbsRefPrefix - устанавливаем его
		
	}
	
		// Лист конвертаций
	protected function cObjPhpTemplate_convert2Int($object) {
		$сonvert2IntConditionList = null;
		
			// Конвертация tsCondition-1-ConvertToUser_INT (если переданы POST-данные)
		if ( !empty($GLOBALS['_POST']) ) {
			$сonvert2IntConditionList[1] = "convert2IntIfSendPost";
		}
		
			// Конвертация tsCondition-2-ConvertToUser_INT (если это белая-третья страница)
		if ( pageTypeColor() == 3 ) {
			$сonvert2IntConditionList[2] = "convert2IntIfWhitePage";
			# print "<h1 STYLE='COLOR: RED;'>convert2IntIfWhitePage</H1>";
		}
		
			// Конвертация tsCondition-3-ConvertToUser_INT (если авторизирован FE-пользователь)
		if ( $GLOBALS['TSFE']->loginUser == 1 ) {
			$сonvert2IntConditionList[3] = "convert2IntIfFeUserAuthorization";
			# print "<h1 STYLE='COLOR: RED;'>convert2IntIfFeUserAuthorization</H1>";
		}
		
			// Так сделал через массив, что бы по несколько раз не прогонять поиск данных в массиве
		if (count($сonvert2IntConditionList) > 0) {
			$object->tmpl->setup = $this->searchInArray_cObjPhpTemplate_convert2Int($object->tmpl->setup, $сonvert2IntConditionList);
			$object->pSetup = $this->searchInArray_cObjPhpTemplate_convert2Int($object->pSetup, $сonvert2IntConditionList);
			#print_r($object->tmpl->setup);
			#print_r($object->pSetup);
		}
	}
	
	/*
		Конвертация объекта в "_INT"
		[test] => PHPTEMPLATE
		[test.] => Array
			(
				[convert2IntIfSendPost] => 1  ->->->->->-> ищем вот это!
				[convert2IntIfWhitePage] => 1  ->->->->->-> или ищем вот это!
				[convert2IntIfFeUserAuthorization] => 1  ->->->->->-> или ищем вот это!
			)
	*/
	public function searchInArray_cObjPhpTemplate_convert2Int($arrayTyposcript, $convert2InfType, $resultSearch) {
		foreach ($arrayTyposcript as $key => $val) {
			if ($val == "PHPTEMPLATE"
			&& (
				$arrayTyposcript[$key."."][$convert2InfType[1]/*'сonvert2IntIfSendPost'*/] == 1
				||
				$arrayTyposcript[$key."."][$convert2InfType[2]/*'convert2IntIfWhitePage'*/] == 1
				||
				$arrayTyposcript[$key."."][$convert2InfType[3]/*'convert2IntIfFeUserAuthorization'*/] == 1
			)) {
				$result[$key] = $val . "_INT"; // в "PHPTEMPLATE_INT"
			} elseif (is_array($val)){
				$result[$key] = $this->searchInArray_cObjPhpTemplate_convert2Int($val, $convert2InfType, $resultSearch);
			} else {
				$result[$key] = $val;
			}
		}
		return $result;
	}
		
		// Если запущена специальная страница index.php?eIdAjax=5
	protected function eIdAjaxWillRun($object) {
		if (isset($GLOBALS['_GET']['eIdAjax'])) {
			
				// Сценарий 1
				// Осуществляем поиск eIdajax в текущем Typoscript шаблоне
			$this->searchInArray_eIdAjaxRegust($object->tmpl->setup);
			
				// Генерация страницы для eIdAjax
			if ($this->eIdAjaxSerched == 1) {
			
					// Вырезаем со страницы все объекты
				$pSetup_tmp = $object->pSetup;
				foreach ($object->pSetup as $key => $value) {
					if (is_numeric($key)){
						unset($pSetup_tmp[$key]);
						unset($pSetup_tmp[$key."."]);
					}
				}
			
					// Создаем объект на странице
				$object->config['config']['no_cache'] = 1;
				$object->config['config']['disableAllHeaderCode'] = 1;
				$object->config['config']['disablePrefixComment'] = 1;
				
				$object->pSetup = $pSetup_tmp;
				# $object->pSetup[10] = "TEXT";
				# $object->pSetup["10."]['value'] = 'Hi eId Ajax ' . rand(1, 10) . '!';
				$object->pSetup[10] = "PHPTEMPLATE_INT";
				$object->pSetup["10."] = $this->eIdAjaxTsParams;
				$object->set_no_cache();
				
					// Также создаем константу что работает режим Ajax
				define('TYPO3_MODE_eIdAjax', TRUE);
				
				// Сценарий 2
				// Осуществляем поиск в папках "pagePartial", "pageContent"
				// Что бы заработал eIdAjax - необходимо создать файлик "eIdAjax.txt" в папке
			} elseif (strstr($GLOBALS['_GET']['eIdAjax'], "fileadmin/")) {
				
				if(strstr($GLOBALS['_GET']['eIdAjax'], "pageContent/") && file_exists(PATH_site.$GLOBALS['_GET']['eIdAjax']."eIdAjax.txt")){
					//print "pageContent"; пока не реализовано!!! - нет необходимости
					print "No realize";
					exit();

				} elseif (strstr($GLOBALS['_GET']['eIdAjax'], "pagePartial/") && file_exists(PATH_site.$GLOBALS['_GET']['eIdAjax']."eIdAjax.txt")){
					// print "pagePartial";
					// exit();
						
						// Получаем объект:
					// $cObj = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::makeInstance('tslib_cObj');
					$cObj = $GLOBALS['TSFE'];
					
						// Вырезаем со страницы все объекты
					$pSetup_tmp = $object->pSetup;
					foreach ($object->pSetup as $key => $value) {
						if (is_numeric($key)){
							unset($pSetup_tmp[$key]);
							unset($pSetup_tmp[$key."."]);
						}
					}
				
						// Создаем объект на странице
					$object->config['config']['no_cache'] = 1;
					$object->config['config']['disableAllHeaderCode'] = 1;
					$object->config['config']['disablePrefixComment'] = 1;
					
					$object->pSetup = $pSetup_tmp;
					$object->pSetup[10] = "TEXT";
					# $object->pSetup[10] = "TEXT";
					# $object->pSetup["10."]['value'] = 'Hi eId Ajax ' . rand(1, 10) . '!';
					$object->pSetup[10] = "PHPTEMPLATE_INT";
					$object->pSetup["10."]["template_file"] = "typo3conf/ext/phptemplate/plugins/sys_template/ajax_template_function.includePartial.php";
					$object->set_no_cache();
					
						// Также создаем константу что работает режим Ajax
					define('TYPO3_MODE_eIdAjax', TRUE);
					
				} else {
					$GLOBALS['TSFE']->pageUnavailableAndExit('user eIdAjax - pageContent or pagePartial with eIdAjax.txt ("' . $GLOBALS['_GET']['eIdAjax'] . '") not found!');
				}
				
			} else {

					// eIdAjax - не найден
				$GLOBALS['TSFE']->pageUnavailableAndExit('user eIdAjax ("' . $GLOBALS['_GET']['eIdAjax'] . '") not found!');
				exit();
			}

		} else {
			
				// Также создаем константу, что режим Ajax не работает
			// define('TYPO3_MODE_eIdAjax', FALSE);
				
		}

	}

	/*
		Поиск объектов с eIdAjaxNumRegust
		[test] => PHPTEMPLATE
		[test.] => Array
			(
				[eIdAjaxNumRegust] => 100  ->->->->->-> ищем вот это!
			)
	*/
	public function searchInArray_eIdAjaxRegust($arrayTyposcript, $resultSearch){
		foreach ($arrayTyposcript as $key => $val) {
			# if ((($val == "PHPTEMPLATE" || $val == "PHPTEMPLATE_INT")
			# && strstr($arrayTyposcript[$key."."]['controller_name'], "&" . $GLOBALS['_GET']['eIdAjax'])
			# && $arrayTyposcript[$key."."]['controller_name.']['eIdAjaxRegust'] > 0)){
			if ((($val == "PHPTEMPLATE" || $val == "PHPTEMPLATE_INT")
			&& $arrayTyposcript[$key."."]['eIdAjaxNumRegust'] == $GLOBALS['_GET']['eIdAjax'])) {
				$this->eIdAjaxTsParams = $arrayTyposcript[$key."."];
				$this->eIdAjaxSerched = 1;
				return 0;
			} elseif (is_array($val)){
				$result[$key] = $this->searchInArray_eIdAjaxRegust($val, $resultSearch);
			} else {
				$result[$key] = $val;
			}
		}
		return $result;
	}

		// Установка заголовка страницы
	protected function setTitleTagValueAlternative(&$object){
		if (isset($object->pSetup['pageTitle.'])){
			$object->config['config']['titleTagFunction'] = "user_titleTagFunction->main";
		}
			/*
				// Устанавливаем название сайта
			if ($object->pSetup['pageTitle.']['sitename'] || $object->pSetup['pageTitle.']['sitename.']){
				# $sitename = $object->cObj->stdWrap($object->pSetup['pageTitle.']['sitename'], $object->pSetup['pageTitle.']['sitename.']);
				$object->config['config']['pageTitleFirst'] = 1;
				$object->tmpl->setup['config.']['pageTitleSeparator'] = ' :: ';
				$object->tmpl->setup['sitetitle'] = 123312;
			}
			*/
	}
	
		// Устанавливаем baseUrl - если не задан
	protected function setBaseUrlIfEmpty(&$object){
		if (empty($object->config['config']['baseURL'])){
			$object->config['config']['baseURL'] = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_SITE_URL');
			# $GLOBALS['TSFE']->baseUrl = \TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('TYPO3_SITE_URL');
			# $GLOBALS['TSFE']->tmpl->setup['config.']['baseURL'] = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_SITE_URL');
		}
	}
		
		// Устанавливаем absRefPrefix - если не задан
	protected function setAbsRefPrefixIfEmpty(&$object){
		if (empty($object->config['config']['absRefPrefix'])){
			$object->config['config']['absRefPrefix'] = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_SITE_URL');
			# $GLOBALS['TSFE']->absRefPrefix = \TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('TYPO3_SITE_URL');
			# $GLOBALS['TSFE']->tmpl->setup['config.']['absRefPrefix'] = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getIndpEnv('TYPO3_SITE_URL');
		}
	}
	
}

?>