<?php
# require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'pi1/tsCondition-2-ConvertToUser_INT.php');
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'pi1/pageTypeColor.php');

class tx_phptemplate_createHashBase {
	function createHashBaseAddBeUserLogined(&$hashParameters, $createLockHashBase) {	
	
			// При условии, что это режим редактирования
		if ($GLOBALS['BE_USER']->uc['phptemplate_mode_editing'] == 2) {
			$hashParameters['hashParameters']['phptemplate_mode_editing'] = 2;
		}
			
			// При условии, что включена шестеренка (настройки)
		if ($GLOBALS['BE_USER']->uc['phptemplate_checkOption'] == 1) {
			$hashParameters['hashParameters']['phptemplate_checkOption'] = 1;
		}
		
			// При условии, что включено показывать маркеры - переводов
		if ($GLOBALS['BE_USER']->uc['phptemplate_checkLocalization'] == 1) {
			$hashParameters['hashParameters']['phptemplate_checkLocalization'] = 1;
		}
		
			// При условии, что включено показывать скрытые записи - глаз на панели...
		if ($GLOBALS['BE_USER']->uc['phptemplate_showHiddenRecords'] == 1) {
			$hashParameters['hashParameters']['phptemplate_showHiddenRecords'] = 1;
		}
			
			// Наверное получается, что данный параметр даже и не нужен был!
		$hashParameters['hashParameters']['beUserLogin'] = $GLOBALS['TSFE']->beUserLogin; 
		
			// Т.к. не получилось исключить параметр "L" из cHash в $TYPO3_CONF_VARS['FE']['cHashExcludedParameters'] - решено сделать пока так для предотвращения бага залипания страницы
		$hashParameters['hashParameters']['sysLanguageUid'] = $GLOBALS['TSFE']->sys_language_uid;
		
			/*
				Конвертация PHPTEMPLATE-обюъектов в -> _INT 
				.convert2IntIfSendPost = 1
				.convert2IntIfWhitePage = 1 
				.convert2IntIfFeUserAuthorization = 1
				Конвертация tsCondition-1-ConvertToUser_INT (если переданы POST-данные - кэширование выключаем)
				Конвертация tsCondition-2-ConvertToUser_INT (если это белая-треться страница - кэширование выключаем)
				Конвертация tsCondition-3-ConvertToUser_INT (если если авторизирован FE-пользователь)
			*/
		
				// tsCondition-1-ConvertToUser_INT // Если существует _POST-данные (для .сonvert2IntIfSendPost=1)
			if (!empty($GLOBALS['_POST'])) {
				$hashParameters['hashParameters']['_POST'] = 1;
			} else {
				$hashParameters['hashParameters']['_POST'] = 0;
			}
			
				// [решил оставить на всякий случай!] Условие также не нужно, т.к. TYPO3 при запросе данных страниц создает их дубликат
				// tsCondition-2-ConvertToUser_INT // Если белая страница (для .сonvert2IntIfWhitePage=1)
			if (pageTypeColor() == 3) {
				$hashParameters['hashParameters']['WhitePage'] = 1;
			} else {
				$hashParameters['hashParameters']['WhitePage'] = 0;
			}
			
				// [решил оставить на всякий случай!] Здесь данное условие не нужно, т.к. в id-кэша TYPO3 и так добавляется группа авторизированности FE-пользователя
				// tsCondition-3-ConvertToUser_INT // Если авторизирован FE-пользователь (для .convert2IntIfFeUserAuthorization=1)
			if ($GLOBALS['TSFE']->loginUser == 1) {
				$hashParameters['hashParameters']['TSFE_loginUser'] = 1;
			} else {
				$hashParameters['hashParameters']['TSFE_loginUser'] = 0;
			}
			
			
			// Добавление тэгов для сброса кэша вирт. страницы
		$GET = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::_GET();
		if (!empty($GET)) {

			if (version_compare(TYPO3_branch, '4.7', '>=')) {
				$cacheHash = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::makeInstance($GLOBALS['TYPO3_CLASS_MIGRATION']['makeInstance']['t3lib_cacheHash']);
				$cHash_array = $cacheHash->getRelevantParameters($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::implodeArrayForUrl('', $GET));
				$cHash_calc = $cacheHash->calculateCacheHash($cHash_array);
			} else {
				$cHash_array = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::cHashParams($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::implodeArrayForUrl('',$GET));
				$cHash_calc = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::calculateCHash($cHash_array);
			}
				
				// useCashHash = 1 // "2" виртуальная страница 
			if (!empty($cHash_array)) {
				$cacheTag = md5(serialize($cHash_array));
				$GLOBALS['TSFE']->addCacheTags(array(0=>"cHash_" . $cacheTag)); // Добавление тэгов для виртаульных страниц, что бы можно было сбросить кэш вирт. 
			}
		}

	}
}
?>