<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014  <Ivan Litovchenko>
 *  All rights reserved
 ***************************************************************/

require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.adminPanel.php');
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.adminPanelNotepad.php');
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.recordStatus.php');

require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.editIcon.php');
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.editIconAbs.php');
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.editIconInline.php');
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.editWrapStart.php');
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.editWrapEnd.php');
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.newIcon.php');

require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.goToModuleIcon.php');
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.eventIcon.php');

/*
	t3lib_frontend::adminPanel();			+
	t3lib_frontend::adminPanel(1);			+
	t3lib_frontend::adminPanelNotepad();	+
	t3lib_frontend::recordStatus();			+

	t3lib_frontend::editIcon();				+
	t3lib_frontend::editIconAbs();			+
	t3lib_frontend::editIconInline();		+
	t3lib_frontend::newIcon();				+
	t3lib_frontend::editWrapStart();		+
	t3lib_frontend::editWrapEnd();			+

	t3lib_frontend::goToModuleIcon();		+
	t3lib_frontend::eventIcon();			+
*/
class t3lib_frontend {
	public function adminPanel($addedToFooter){
		return phptemplate_plugin_adminPanel(false, $addedToFooter);
	}
	
	public function adminPanelNotepad($addedToFooter){
		return phptemplate_plugin_adminPanelNotepad(false);
	}
	
	public function recordStatus($table = "tt_content", $recordId = 0){
		return phptemplate_plugin_recordStatus(false, $table, $recordId);
	}
	
	public function editIcon($table = "tt_content", $recordId = 0, $title = "", $otherArg = array()){
		return phptemplate_plugin_editIcon(false, $table, $recordId, $title, $otherArg, 0);
	}
	
	public function editIconAbs($table = "tt_content", $recordId = 0, $title = "", $otherArg = array()){
		return phptemplate_plugin_editIconAbs(false, $table, $recordId, $title, $otherArg);
	}
	
	public function editIconInline($table = "tt_content", $recordId = 0, $title = "", $otherArg = array()){
		return phptemplate_plugin_editIconInline(false, $table, $recordId, $title, $otherArg);
	}
	
	public function newIcon($table = "tt_content", $pidId = 0, $title = "", $otherArg = array()){
		return phptemplate_plugin_newIcon(false, $table, $pidId, $title, $otherArg);
	}
	
	public function editWrapStart($cssInline = FALSE){
		return phptemplate_plugin_editWrapStart(false, $cssInline);
	}
	
	public function editWrapEnd(){
		return phptemplate_plugin_editWrapEnd(false);
	}
	
	public function goToModuleIcon($moduleName = "", $pidId = 0, $title = "", $otherArg){
		return phptemplate_plugin_goToModuleIcon(false, $moduleName, $pidId, $title, $otherArg);
	}
	
	public function eventIcon($url = "", $icon = '', $title = "", $otherArg = array()){
		return phptemplate_plugin_eventIcon(false, $url, $icon, $title, $otherArg);
	}
}

?>