<?php
/*
	pageContentWithGridelement (for EXT:gridelements)
	@ pid
	@ colPos 		(определяется автоматически)
	@ gridContainer (определяется автоматически)
	@ gridColumns
*/
require_once ( t3lib_extMgm::extPath('phptemplate') . "plugins/function.editIcon.php" );
function phptemplate_plugin_pageContentWithGridelements($self, $pid = "_self", $gridColumns = 0) {

	if (!t3lib_extMgm::isLoaded('gridelements')) {
		return tx_phptemplate_error_wrap("Extension \"gridelements\" not loaded for plugin pageContentWithGridelements()!");
	}

		// select.where
	$selectWhere = null;

		// for extension gridelements
	$colPos = $self->cObj->data['colPos'];
	$gridContainer = $self->cObj->data['uid'];
	if ($gridContainer > 0) {	
		$selectWhere[] = "     tx_gridelements_container=" . intval($gridContainer) . " ";
		$selectWhere[] = " AND tx_gridelements_columns=" . intval($gridColumns) . " ";
	}
	
	$tsConf = array(
		'table' => 'tt_content',
		'select.' => array(
			'pidInList' => ( $pid == "_self" ) ? $GLOBALS['TSFE']->id : intval($pid),
			'orderBy' => 'sorting',
			'where' => implode(" ", $selectWhere),
			'languageField' => 'sys_language_uid',
		),
		/*
			lib.content.stdWrap.ifEmpty.cObject = TEXT
			lib.content.stdWrap.ifEmpty.cObject.data = DB:tx_web_settings:1:text_for_under_construction
		*/
		'stdWrap.' => array (
			'ifEmpty.' => array ( 
				'cObject' => 'TEXT',
				'cObject.' => array (
					'value' => '
						<img src="'.t3lib_div::getIndpEnv('TYPO3_REQUEST_HOST').'/typo3conf/ext/phptemplate/plugins/res/pageUnderConstructionIfEmptyContent.png" width="50%" style="max-width: 300%;" align="center">
						<br /><!--Содержимое в процессе наполнения!-->
						'.$GLOBALS['TSFE']->sL('LLL:EXT:phptemplate/locallang.xml:plugins.contentInTheProcessOfFilling').'
					'
				)
			)
		)
	);
	
		// При условии, что это режим редактирования
	if ($GLOBALS['BE_USER']->uc['phptemplate_mode_editing'] == 2) {
		$editIconCreateNewRecord = phptemplate_plugin_editIcon_marker (
			'tt_content', 
			0, 
			$GLOBALS['LANG']->sL('LLL:EXT:phptemplate/locallang.xml:plugins.pageContent.addTheContentsOfTheGridContainer'), // Добавить содержимое в контейнер
			array (
				'isNewRecord_tt_content' => 1, 
				"isNewRecord_tt_content_arValue" => array(
					"pid" => ( $pid == "_self" ) ? $GLOBALS['TSFE']->id : intval($pid),
					"colPos" => intval($colPos),
					"tx_gridelements_container" => intval($gridContainer),
					"tx_gridelements_columns" => intval($gridColumns)
				)
			) 
		);
	}
	
	return $editIconCreateNewRecord .
		$self->cObj->cObjGetSingle(
		"CONTENT",
		$tsConf
	);
	
}
?>