<?php
/*
	@ parameter
	@ additionalParams
	@ useCacheHash
	@ forceAbsoluteUrl
	
	typolink {
		parameter = 13
		additionalParams = &...
		forceAbsoluteUrl = 1
		forceAbsoluteUrl.scheme = https
		returnLast = 1
	}
*/
function phptemplate_plugin_url($self, $parameter = "_self", $additionalParams = array(), $useCacheHash = false, $forceAbsoluteUrl = true) {
	
		// if self parameter
	if ($parameter == "_self") {
		$parameter = $GLOBALS['TSFE']->id;
	}
	
		// clear additionalParams
	$newAdditionalParams = "";
	if (count($additionalParams) > 0) {
		foreach ($additionalParams as $key => $value) {
			if ($value != null) {
				$newAdditionalParams .= "&" . $key . "=" . $value;
			}
		}
	}
		
		// Get the typolink
	$tsConf = array(
		'parameter' => $parameter,
		'additionalParams' => $newAdditionalParams,
		'useCacheHash' => $useCacheHash,
		'returnLast' => 'url',
	);
	return $self->cObj->typolink("", $tsConf);
	
	
}
?>